/*
 *     
 */

#include "head.h"

Rect Dirty(1000,1000,0,0);      // ,   

// *** Rect *** // 
Rect::Rect (int AX,int AY,int BX,int BY)
{ A.X=AX; A.Y=AY;
  B.X=BX; B.Y=BY;
};

Rect::Rect (const Rect &R)
{ A.X=R.A.X; A.Y=R.A.Y;
  B.X=R.B.X; B.Y=R.B.Y;
};

Rect::Rect (int SX, int SY)     //  
{       A.X=(SWIDTH+1-SX)/2; B.X=A.X+SX;
        A.Y=(SHIGHT+1-SY)/2; B.Y=A.Y+SY;
};

void Rect::Center()
{ int SX=B.X-A.X;
  int SY=B.Y-A.Y;
        A.X=(SWIDTH+1-SX)/2; B.X=A.X+SX;
        if (A.X<0) A.X=0;
        if (B.X>SWIDTH) B.X=SWIDTH;
        A.Y=(SHIGHT+1-SY)/2; B.Y=A.Y+SY;
};

void Rect::Assign (int AX,int AY,int BX,int BY)
{ A.X=AX; A.Y=AY;
  B.X=BX; B.Y=BY;
};

void Rect::Assign (const Rect &R)
{ A.X=R.A.X; A.Y=R.A.Y;
  B.X=R.B.X; B.Y=R.B.Y;
};

// *** View *** //  '
View::View (const Rect &R): Rect(R)
{ Owner=NULL;
  Prev=Next=NULL;
  State=0; Options=ofSelectable;
}

View::~View()
{       if (Owner==NULL) return;
        if (Prev) Prev->Next=Next;
        if (Owner->First==this) Owner->First=Next;
        if (Next) Next->Prev=Prev;
        if (Owner->Last==this) Owner->Last=Prev;
        if (Owner->Current==this) Owner->Current=Owner->First;
} //~View

unsigned View::getsym()
{ return ::getsym();
}

void View::SetState (int Stat)
{       if (State!=Stat)
        {       State=Stat;
                DrawView();
        }
} //View::SetState

//  '   
void View::Select ()
{ View *p;
        if (Owner==NULL) return;
        if (State) return;
        for (p=Owner->First; p; p=p->Next)
           if (p==this)
           {    Owner->Current->SetState(0);
                Owner->Current=this;
                SetState(1);
                return;
           }
} //View::Select

void View::Hide()
{ Options|=ofHidden; }

int View::hidden()
{ return (!State&&(Options&ofHidden));
}

void View::Show()
{       Options&=~ofHidden;
        DrawView();
}

void View::Assign (int AX,int AY,int BX,int BY)
{ Rect::Assign(AX,AY,BX,BY); }

void View::Assign (const Rect &R)
{ Rect::Assign(R); }

Rect View::getBounds()
{       return Rect(*this);
}

Point View::Size()
{       return (Point(B.X-A.X,B.Y-A.Y));
}

//     
Rect View::getCoord()
{ Rect R=Rect(A.X,A.Y,B.X,B.Y);
        if (Owner)
        {       Rect RR=Owner->getCoord();
                R.Assign(R.A.X+RR.A.X,R.A.Y+RR.A.Y,
                         R.B.X+RR.A.X,R.B.Y+RR.A.Y);
        }
        return R;
} //View::getCoord

//   ( )
void View::curxy (int x, int y)
{       if (Owner) Owner->curxy(x+Owner->A.X,y+Owner->A.Y);
        else    ::curxy(x,y);
} //View::curxy

//  
int View::Color (int cnum)
{       if (Owner) return Owner->Color(cnum);
        else return ::Color(cnum);
} //View:Color

void View::DrawView()
{       if (Owner==NULL) return;
        if (!Owner->drawed) return;
        if ((Options&ofHidden)&&!State) return;
        Draw();
} //View::DrawView

void View::Draw()
{ int x,y;
        if (Owner==NULL) return;
        y=A.Y;
        for (; y<B.Y; y++)
        {       x=A.X;
                if (x>SWIDTH) break;
                curxy(x,y);
                for (; x<B.X; x++)
                        pch(' ');
        }
        curxy(A.X,A.Y);
} //View::Draw

int View::Visual()
{       return State||!(Options&ofHidden);
}

unsigned View::Handle (unsigned &c)
{       return 0;
}

// *** Group *** //  '
Group::Group (const Rect &R): View(R)
{ Last=First=Current=NULL;
  drawed=0;
} //Group

Group::~Group()
{ View *p=First;
  View *pp;
        while (p)
        {       pp=p->Next;
                delete p;
                p=pp;
        }
} //~Group

void Group::Assign (int AX,int AY,int BX,int BY)
{ A.X=AX; A.Y=AY;
  B.X=BX; B.Y=BY;
};

void Group::Assign (const Rect &R)
{ A.X=R.A.X; A.Y=R.A.Y;
  B.X=R.B.X; B.Y=R.B.Y;
};

//  '  
int Group::Insert (View *p)
{       if (First==NULL) First=p;
        if (Last==NULL) Last=First;
        if (Current) Current->SetState(0);

        View *pp=Last;
        if (pp!=p) p->Prev=pp;
        p->Next=pp->Next;
        if (pp->Next) pp->Next->Prev=p;
        if (pp!=p) pp->Next=p;
        p->Owner=this;
        p->SetState(1);
        Last=Current=p;
        return 1;
} //Group::Insert

int Group::Remove (View *p)
{       if (First==NULL) return 0;
        View *pp;
        for (pp=First; pp; pp=pp->Next)
                if (p==pp) break;
        if (pp==NULL) return 0;
        if (p->Prev) p->Prev->Next=p->Next;
        if (p->Next) p->Next->Prev=p->Prev;
        if (Current==p) Current=p->Next;
        if (First==p) First=p->Next;
        if (Last==p) Last=p->Prev;
        if (Current==NULL) Current=First;
        if (Current && !(Current->Options&ofSelectable)&&Current->Next)
                Current=Current->Next;
        if (Current) Current->State=1;
        return 1;
} //Group::Remove

void Group::RemoveAll ()
{       while (First!=Last) Remove(First);
        while (Remove(First));
} //Group::RemoveAll

//  ./. ' 
void Group::SelectNext (int forward)
{ View *p;
        if (Current==NULL) return;
        Current->SetState(0);
        p=Current;
        do
        {       if (forward)
                {       if (Current->Next)
                                Current=Current->Next;
                        else    Current=First;
                }
                else
                {       if (Current->Prev)
                                Current=Current->Prev;
                        else    Current=Last;
                }
                if (p==Current) break;
        }
        while (!(Current->Options&ofSelectable));
        Current->SetState(1);
} //Group::SelectNext

//  
int Group::Color (int cnum)
{       return ::Color(cnum);
} //Group::Color

void Group::DrawView()
{       if ((Owner!=NULL)&&!Owner->drawed) return;
        if ((Options&ofHidden)&&!State) return;
        Draw();
} //Group::DrawView

//   '   ( - )
void Group::Draw()
{ View *p;
        drawed=1;
        Color(0);
        for (p=First; p; p=p->Next)
            if (p!=Current) p->DrawView();
        if (Current) Current->DrawView();
} //Group::Draw

void Group::Hide()
{ //for (View *p=First; p; p=p->Next) p->Hide();
  View::Hide();
}

void Group::Show()
{ //for (View *p=First; p; p=p->Next) p->Show();
  View::Show();
}

//    
//         PreProcess
//   -    
//   -   -  PreProcess  PostProcess
//   -   PostProcess
unsigned Group::Handle (unsigned &c)
{ View *p;
  int res;

        if (Current==NULL) return 0;
        res=Current->Handle(c);
        if (res||!c) return res;

        for (p=First; p; p=p->Next) //    PreProcess
        {       if (p==Current) continue;
                if (p->Options&ofPreProcess)
                {       res=p->Handle(c);
                        if (res||!c) return res;
                }
        }

        switch (c)
        { case _Tab:
          case _Right:
          case _Down:
                SelectNext(1);
                return 0;
          case _Left:
          case _Up:
                SelectNext(0);
                return 0;
          case _Refresh:
                drawed=0;
                Center();
                DrawView();
                return 0;
          case _Esc:
          case _F10:
                return cmCancel;
        }

        for (p=First; p; p=p->Next) //    PreProcess
        {       if (p==Current) continue;
                if (!(p->Options&(ofPreProcess|ofPostProcess)))
                {       res=p->Handle(c);
                        if (res||!c) return res;
                }
        }

        for (p=First; p; p=p->Next) //    PostProcess
        {       if (p==Current) continue;
                if (p->Options&ofPostProcess)
                {       res=p->Handle(c);
                        if (res||!c) return res;
                }
        }

        return 0;
} //Group::Handle

//     -   '
unsigned Group::getsym()
{ return Current->getsym(); }

void Group::ForEach (void (*proc)(View*,int))
{ View *p;
  int i;
        for (p=First,i=0; p; p=p->Next,i++)
                (*proc)(p,i);
} //Group::ForEach

Group *Running=NULL;

//   
unsigned Group::Exec()
{ unsigned res,c;
  Group *oldRunning=Running;
        Running=this;
        DrawView();
        for(;;)
        {       c=getsym();
                res=Handle(c);
                if (res) return res;
        }
        Running=oldRunning;
} //Group::Exec

// *** Dialog *** //  
Dialog::Dialog (const Rect &R, char *txt, int shadow): Group(R)
{ Name=txt;
  Shadow=shadow;
  Rect T=getBounds();
  if (Shadow)
  {     T.A.X-=2; T.A.Y--;
        T.B.X+=2; T.B.Y++;
  }
  if (T.A.X<Dirty.A.X) Dirty.A.X=T.A.X;
  if (T.A.Y<Dirty.A.Y) Dirty.A.Y=T.A.Y;
  if (T.B.X>Dirty.B.X) Dirty.B.X=T.B.X;
  if (T.B.Y>Dirty.B.Y) Dirty.B.Y=T.B.Y;
  Build=NULL;
} //Dialog

//    
unsigned Dialog::getsym()
{ kbdmin();
  unsigned c=Group::getsym();
  kbdmax();
  return c;
} //Dialog::getsym

//  
int Dialog::Color (int cnum)
{       return Group::Color(cnum);
} //Dialog::Color

void Dialog::Draw()
{ int x,y,lx;
        if (B.X>=SWIDTH-4) B.X=SWIDTH-5;
        if (A.X>=B.X-5) A.X=B.X-6;
        if (A.X<2) A.X=2;
        if (drawed)
        {       Group::Draw();
                return;
        }
        Color(8);
        //  
        if (Shadow)
        {       curxy(A.X-2,A.Y-1);
                for (x=A.X-2; x<=B.X+3; x++) pch(' ');
        }

        //  
        x=A.X; y=A.Y;
        lx=x+((B.X-A.X)-StrLen(Name))/2-2;
        if (Shadow) x-=2;
        curxy(x,y);
        if (Shadow) prt("  ");
        prt(_graph_on);
        pch(_graph[_lu]);
        for (++x; x<lx; x++) pch(_graph[_uu]);
        if (Name[0])
        {        prt(_graph_off);
                pch(' '); prt(Name); pch(' ');
                prt(_graph_on);
                x+=StrLen(Name)+2;
        }
        for (; x<B.X-1; x++) pch(_graph[_uu]);
        pch(_graph[_ru]);
        if (Shadow) prt("  ");

        //  
        for (++y; y<B.Y-1; y++)
        {       x=A.X;
                if (Shadow) x-=2;
                curxy(x,y);
                if (Shadow) prt("  ");
                pch(_graph[_ll]);
                for (++x; x<B.X-1; x++) pch(' ');
                pch(_graph[_rr]);
                if (Shadow) prt("  ");
        }

        //  
        x=A.X;
        if (Shadow) x-=2;
        curxy(x,y);
        if (Shadow) prt("  ");
        pch(_graph[_ld]);
        for (++x; x<B.X-1; x++) pch(_graph[_dd]);
        pch(_graph[_rd]);
        prt(_graph_off);
        if (Shadow) prt("  ");

        //  
        if (Shadow)
        {       curxy(A.X-2,B.Y);
                for (x=A.X-2; x<=B.X+3; x++) pch(' ');
        }

        Group::Draw();
} //Dialog::Draw

unsigned Dialog::Handle (unsigned &c)
{       if (c==_Refresh)
        {       if (Build)
                {       View *p;
                        int i=0,n=0;
                        for (i=0,p=Group::First; p; p=p->Next, i++)
                                if (p==Group::Current) n=i;
                        RemoveAll();
                        (*Build)(this);
                        for (i=0,p=Group::First; p; p=p->Next, i++)
                                if (i==n) p->Select();
                }
        }
        return Group::Handle(c);
} //Dialog::Handle

// *** Button *** // 
Button::Button (const Rect &R, char *txt, char K, int cmd, int flags): View(R)
{       Text=txt;
        Command=cmd;
        Key=toupper(K);
        if (flags&sfDefault)
                Options|=ofPreProcess;
} //Button

void Button::Draw()
{ char *p;
  int x,ll,cflag;
        if (Owner==NULL) return;
        if (B.X>(Owner->B.X-Owner->A.X)) B.X=(Owner->B.X-Owner->A.X);
        curxy(A.X,A.Y);
        if (State)
                cflag=Color(9);
        else    cflag=Color(8);
        ll=((B.X-A.X)-StrLen(Text))/2;
        if (!cflag) ll-=1;
        for (x=A.X; x<A.X+ll; x++) pch(' ');
        if (!cflag) {pch(State?'>':' '); x++;}
        for (p=Text; *p; x++, p++)
                pch(*p);
        if (!cflag)
        {       pch(State?'<':' ');
                x++;
        }
        for ( ; x<B.X; x++)
                pch(' ');
        Color(0);
        curxy(A.X,A.Y);
} //Button::Draw

unsigned Button::Handle (unsigned &c)
{       if ((c==_Enter)||((toupper(c)|0100)==Key))
                return Command;
        else    return 0;
} //Button::Handle

// *** StaticText *** //  
StaticText::StaticText (const Rect &R, char *txt): View(R)
{       Text=txt;
        Options=0;
}

void StaticText::Draw()
{ char *p;
  int x=A.X;
  int y=A.Y;
        if (B.X>(Owner->B.X-Owner->A.X)) B.X=(Owner->B.X-Owner->A.X);
        curxy(x,y);
        Color(8);
        for (p=Text; *p&&(y<B.Y); p++)
        {       if (*p!='\n')
                {       x++;
                        if (x<B.X)
                        {   if ((unsigned)(*p)>=' ') pch(*p);
                            else
                            {   pch('^'); x++;
                                if (x<B.X) pch(*p+0100);
                            }
                        }
                }
                else
                {       y++; x=A.X;
                        curxy(x,y);
                }
        }
        Color(0);
        ::curxy(SWIDTH,SHIGHT);
} //StaticText::Draw

// *** CheckBox *** // "/"
CheckBox::CheckBox (const Rect &R, char *txt, char K, unsigned *chk): View(R)
{       Text=txt;
        Key=K;
        Check=chk;
} //Button

void CheckBox::Draw()
{       if (Owner==NULL) return;
        if (Check==NULL) return;
        if (B.X>(Owner->B.X-Owner->A.X)) B.X=(Owner->B.X-Owner->A.X);
        Color(8);
        curxy(A.X,A.Y);
        if (*Check)
                prt("[X] ");
        else    prt("[ ] ");
        char *p=Text;
        int pos=A.X+4;
        while (*p && pos<B.X)
        {       pch(*p++);
                pos++;
        }
        Color(0);
        curxy(A.X+1,A.Y);
} //CheckBox::Draw

unsigned CheckBox::Handle (unsigned &c)
{       if (Check==NULL) return 0;
        if (((c==040)&&State)||((toupper(c)|0100)==Key))
        {       *Check=!*Check;
                Select();
                DrawView();
                c=0;
        }
        return 0;
} //CheckBox::Handle

// *** InputLine *** //      
InputLine::InputLine (const Rect &R, char *name, char K,
                        char *line, unsigned len): View(R)
{       Name=name;
        Str=line;
        Key=K;
        length=len;
        x=offset=oo=0;
        first=1;
        Options|=ofPostProcess;
} //InputLine

int InputLine::cprtn (char *str, int len, int First)
{ char *p;
  int i;
  int NCol,CCol;
        if (str==NULL) return 0;
        if (First)
                NCol=CCol=10;
        else    NCol=11,CCol=12;
        for (p=str,i=0; *p && (i<len); p++, i++)
        {       if (*p==TAB)
                {       Color(CCol);
                        pch('_');
                }
                else if ((unsigned)(*p)<' ')
                {       Color(CCol);
                        pch(*p+0100);
                }
                else
                {       Color(NCol);
                        pch(*p);
                }
        }
        Color(NCol);
        if (i>=len) return 1;
        for (; i<len; i++) pch(' ');
        return 0;
} //cprtn

void InputLine::Draw()
{       if (Owner==NULL) return;
        if (Str==NULL) return;
        if (B.X>(Owner->B.X-Owner->A.X)) B.X=(Owner->B.X-Owner->A.X);
        Color(8);
        curxy(A.X,A.Y);
        prt(Name);
        Color(0);
        oo=0;
        curxy(A.X+StrLen(Name),A.Y);
        if (offset)
        {       Color(13);
                pch('<');
                oo=1;
        }
        if (first) Color(10);
        else Color(11);

        if (cprtn(Str+offset,Size().X-StrLen(Name)-oo,first))
        {       Color(13);
                pch('>');
        }
        else    pch(' ');

        Color(0);
        CurPos();
//      curxy(A.X+StrLen(Name)+oo+x-offset,A.Y);
} //InputLine::Draw

void InputLine::DrawLine()
{ int xx=x;
        if (Owner==NULL) return;
        if (Str==NULL) return;
        if (xx>0) xx--;
        oo=0;
        if (offset) oo=1;
        if (((oo+xx-offset)<=0) && (offset>0)) xx++;
        curxy(A.X+StrLen(Name)+oo+xx-offset,A.Y);
        if (first) Color(10);
        else Color(11);  //3
        int len=Size().X-StrLen(Name)-oo-(xx-offset);
        if (len>StrLen(Str+xx)+1) len=StrLen(Str+xx)+1;
        if (cprtn(Str+xx,len,0))
        {       Color(2);
                pch('>');
        }
        else    pch(' ');

        Color(0);
        CurPos();
//      curxy(A.X+StrLen(Name)+oo+x-offset,A.Y);
} //InputLine::DrawLine

void InputLine::SetState (int Stat)
{       if (State!=Stat)
        {       State=Stat;
                //DrawView();
                CurPos();
        }
} //InputLine::SetState

void InputLine::CurPos()
{       curxy(A.X+StrLen(Name)+oo+x-offset,A.Y);
}

unsigned InputLine::Handle (unsigned &c)
{ int oldoffs=offset;
  int modified=0;
  int i;

        if (Str==NULL) return 0;
        if (!State&&c!=_Enter)
        {       if ((toupper(c)|0100)==Key)
                {       Select();
                        DrawView();
                }
                return 0;
        }
        switch (c)
        { case _Left:
                if (x>0)
                   x--;
                if ((x<offset)&&(offset>0))
                   offset-=8;
                c=0;
                break;
          case _Right:
                if (x<StrLen(Str))
                   x++;
                if (x-offset>=Size().X-StrLen(Name)-2)
                   offset+=8;
                c=0;
                break;
          case _Home:
                x=offset=0;
                c=0;
                break;
          case _End:
                x=StrLen(Str);
                while (x-offset>=Size().X-StrLen(Name)-2)
                        offset+=8;
                while (x-offset<0)
                        offset-=8;
                c=0;
                break;
          case _BS:
                c=0;
                if (x<=0) break;
                x--;
                for (i=x; i<(int)length; i++) Str[i]=Str[i+1];
                if ((x<offset)&&(offset>0))
                        offset-=8;
                modified=1;
                break;
          case _Del:
                if (x>=StrLen(Str)) break;
                for (i=x; i<(int)length; i++) Str[i]=Str[i+1];
                modified=1;
                c=0;
                break;
          case _delLine:
                Str[0]=0;
                x=offset=0;
                Select();
                modified=1;
                c=0;
                DrawView();
                break;
          case _ctrlPrefix:
                ctrl=1;
                return 0;
          case _Reframe:
                return 0;
          default:
                if ((c==_Enter)&&(!ctrl)) return cmOK;
                if ((c<' ')&&(!ctrl)) break;
                if (c>=0xFF) break;
                if (first) Str[0]=0;
                if (StrLen(Str)>=(int)length) break;
                for (i=StrLen(Str); i>=x; i--) Str[i+1]=Str[i];
                Str[x]=c;
                x++;
                if (x-offset>=Size().X-StrLen(Name)-2)
                        offset+=8;
                Select();
                c=0;
                modified=1;
        } //switch(c)
        ctrl=0;

        if (modified&&first)
        {       first=0;
                DrawView();
        }
        else if (offset!=oldoffs)
                DrawView();
        else if (first)
        {       first=0;
                DrawView();
        }
        else if (modified)
                DrawLine();
        else    CurPos();
        first=0;
        return 0;
} //InputLine::Handle
