/*
 *     ,   .
 */

//   
#define cmCancel        2001
#define cmOK            2002
#define cmYes           2003
#define cmNo            2004

//  
#define cm_             3000
#define cmReDraw        3000
#define cmFrame         3001
#define cmFrameDraw     3002
#define cmKeys          3004
#define cmKeysDraw      3005
#define cmSave          3006
#define cmSaveAll       3007
#define cmClose         3008
#define cmCloseAll      3009
#define cmZoom          3010
#define cmReSize        3011
#define cmSaveStat      3012
#define cmSwitchEdit    3013
#define cmGetName	3014

//  View
#define ofSelectable    1
#define ofPreProcess    2
#define ofPostProcess   4
#define ofHidden        8

//  Button
#define sfDefault       1

// 
struct Point
{ int X,Y;
  Point () {X=Y=0;};
  Point (int x,int y) {X=x;Y=y;};
  Point (const Point &P) {X=P.X; Y=P.Y;};
};

// 
class Rect
{
 public:
  Point A,B;
  Rect (int AX,int AY,int BX,int BY);
  Rect (int SX, int SY);        //  
  Rect (const Rect &R);
  void Center();
  void Assign (int AX,int AY,int BX,int BY);
  void Assign (const Rect &R);
};

extern Rect Dirty;      //   ,  

class Group;

//  '
class View: public Rect
{
 protected:
   int State;                           // 
   int Options;                         // 
   View *Prev, *Next;                   // .  . '  
   virtual void Draw();                 //  '
   virtual unsigned getsym();           //    
 public:
   Group *Owner;                        // 
   View (const Rect &R);
   virtual ~View();
   virtual void DrawView();             // 
   virtual int Color (int cnum);        // . 
   virtual unsigned Handle (unsigned &c);       // - 
   virtual void SetState (int Stat);    // . 
   virtual void Select();               //  
   virtual void Hide();
   virtual void Show();
   virtual int hidden();
   virtual void Assign (int AX,int AY,int BX,int BY);
   virtual void Assign (const Rect &R);
   virtual int Visual();
   virtual void curxy (int x, int y);   // .  (.)
   virtual Rect getBounds();
   virtual Rect getCoord();             // . 
   virtual Point Size();                // 
 friend class Group;
 friend class Dialog;
};

// 
class Group: public View
{ protected:
   virtual void Draw();
   unsigned getsym();
  public:
   int drawed;                          //    
   View *First, *Last, *Current;        // , .,  '
   Group (const Rect &R);
   virtual ~Group();
   virtual void DrawView();
   virtual int Color (int cnum);
   virtual unsigned Handle (unsigned &c);
   virtual int Insert (View *p);        //  '
   virtual int Remove (View *p);
   virtual void RemoveAll ();
   virtual void SelectNext (int forward=1);     //  / 
   virtual unsigned Exec();             //  
   virtual void Assign (int AX,int AY,int BX,int BY);
   virtual void Assign (const Rect &R);
   virtual void Hide();
   virtual void Show();
   virtual void ForEach(void (*proc)(View*,int));
  friend class View;
};

//  
class Dialog: public Group
{  View *First, *Last, *Current;
   char *Name;
  protected:
   virtual void Draw();
   int Shadow;          //   ?
  public:
   Dialog (const Rect &R, char *txt="", int shadow=0);
   void (*Build)(Dialog *D);    // ()
   virtual unsigned Handle (unsigned &c);
   virtual int Color (int cnum);
   virtual unsigned getsym();           //    
  friend class View;
};

// 
class Button: public View
{ protected:
   char *Text;          // 
   char Key;            // "" 
   int Command;         // ,  
   virtual void Draw();
  public:
   Button (const Rect &R, char *txt, char K, int cmd, int flags=0);
   virtual unsigned Handle (unsigned &c);
};

// 
class StaticText: public View
{  char *Text;          // 
  protected:
   virtual void Draw();
  public:
   StaticText (const Rect &R, char *txt);
};

// 
class CheckBox: public View
{ protected:
   char *Text;          // 
   char Key;            // "" 
   unsigned *Check;     //  

   virtual void Draw();
  public:
   CheckBox (const Rect &R, char *txt, char K, unsigned *chk);
   virtual unsigned Handle (unsigned &c);
};

// 
class InputLine: public View
{ protected:
   char *Name;          // 
   char Key;            // "" 
   unsigned length;     // . 
   char *Str;           //   
   int x, offset, oo, first;

   virtual void Draw();
   virtual void DrawLine();
   void SetState (int Stat);

   int cprtn (char *str, int len, int first);
   void CurPos();
  public:
   InputLine (const Rect &R, char *name, char K, char *line, unsigned len);
   virtual unsigned Handle (unsigned &c);
};

//  ()  
class Frame:public Group
{ public:
   virtual void Draw();
   Frame(const Rect &R):Group(R) {};
   virtual unsigned Handle (unsigned &c);
};

//  
class ParamText:public View
{ void *Val;                            //   
  char *Format;                         //  
  char oldstr[80];                      //  
  void (*Get)(char*,char*,void*);       //   -
 protected:
  virtual void Draw();
  virtual void ReDraw();
 public:
   virtual unsigned Handle (unsigned &c);
   ParamText (const Rect &R, char *fmt, void (*get)(char*,char*,void*), void *val)
                :View(R)
   { Format=fmt; Get=get; Val=val; oldstr[0]=0;};
}; //ParamText

//   
class KeyBar:public View
{ char **keys,**oldkeys;
  int drawed;
 protected:
   virtual void Draw();
   virtual void ReDraw();
 public:
   virtual unsigned Handle (unsigned &c);
   KeyBar(const Rect &R,char **k);
   char **SetKeys(char **k);
};

extern int Color (int); //   ()

//   - ( ParamText)
extern void _Num_ (char *str, char *fmt, void *val);
extern void _Num_1 (char *str, char *fmt, void *val);
extern void _Str_ (char *str, char *fmt, void *val);
extern void _Ins_ (char *str, char *fmt, void *val);
extern void _Rus_ (char *str, char *fmt, void *val);
extern void _Star_ (char *str, char *fmt, void *val);
extern void _Arrow_ (char *str, char *fmt, void *val);
extern void _Lines_ (char *str, char *fmt, void *val);
