/*
 *   
 */
#include "head.h"
#ifdef __MSDOS__
#include <dir.h>
#else
#include <dirent.h>
#endif

//   
Line *CreateLine (char *buf)
{ Line *p= (Line*)new char[sizeof(Line)+StrLen(buf)];
  strcpy(p->Text,buf);
  p->Prev=p->Next=NULL;
  return p;
};

FileList::FileList (const Rect &R, Line **ptr, char K):View(R)
{       First=ptr;
        offs=pos=offs0=pos0=0;
        Key=K;
        Pat[0]=0;
        size=getSize();
}

int FileList::getSize()
{ Line *p;
  int i;
        if (First==NULL) return 0;
        for (p=*First, i=0; p; p=p->Next, i++);
        return i;
} //FileList::getSize

void FileList::Draw()
{ char str[80];
  char buf[80];
  int i;
        if (B.X>(Owner->B.X-Owner->A.X)) B.X=(Owner->B.X-Owner->A.X);
        size=getSize();
        for (i=offs; A.Y+i-offs<B.Y; i++)
        {       getLine(str,i);
                curxy(A.X,A.Y+i-offs);
                Color(8);
                if (State&&(i==pos))
                     Color(15);
                else Color(8);
                sprintf(buf,"%-*s",B.X-A.X+1,str);
                prt(buf);
        }
        curxy(A.X+StrLen(Pat),A.Y+pos-offs);
        pos0=pos;
} //FileList::Draw

void FileList::ReDraw()
{ char str[80];
  char buf[80];
        if (offs0!=offs) Draw();
        else
        {       getLine(str,pos0);
                curxy(A.X,A.Y+pos0-offs);
                Color(8);
                sprintf(buf,"%-*s",B.X-A.X+1,str);
                prt(buf);
                getLine(str,pos);
                curxy(A.X,A.Y+pos-offs);
                if (State)
                     Color(15);
                else Color(8);
                sprintf(buf,"%-*s",B.X-A.X+1,str);
                prt(buf);
        }
        curxy(A.X+StrLen(Pat),A.Y+pos-offs);
        pos0=pos;
        offs0=offs;
} //FileList::ReDraw

void FileList::getLine (char *str, int num)
{ Line *p;
  int i;
        if (num<0) num=pos;
        *str=0;
        if (First==NULL) return;
        for (p=*First, i=0; p&&(i!=num); p=p->Next, i++);
        if (p)  strcpy(str,p->Text);
} //FileList::getLine

int Match (char *str, char *pat)
{       if (str==NULL) return 0;
        if (pat==NULL) return 0;
        return strncmp(str,pat,strlen(pat))==0;
} //Match

int FileList::Find (char *S, int n)
{ int i;
  char str[80];
        if (n>=size) n=0;
        for (i=n; i<size; i++)
        {       getLine(str,i);
                if (Match(str,S))
                {       pos=i;
                        if (pos<offs) offs=pos;
                        while (pos>offs+(B.Y-A.Y-1)) offs++;
                        ReDraw();
                        return 1;
                }
        }
        for (i=0; i<n; i++)
        {       getLine(str,i);
                if (Match(str,S))
                {       pos=i;
                        if (pos<offs) offs=pos;
                        while (pos>offs+(B.Y-A.Y-1)) offs++;
                        ReDraw();
                        return 1;
                }
        }
        return 0;
} //FileList::Find

unsigned FileList::Handle (unsigned &c)
{       if (!State)
        {       if ((toupper(c)|0100)==Key)
                {       Select();
                        DrawView();
                }
                return 0;
        }
        if ((' '<=c)&&(c<=255))
        { int len=StrLen(Pat);
                Pat[len]=c;
                Pat[len+1]=0;
                if (!Find(Pat,pos))
                {       Pat[len]=0;
                }
                c=0;
        }
        else
        switch (c)
        { case _BS:
                if (*Pat)
                {       Pat[StrLen(Pat)-1]=0;
                        ReDraw();
                }
                c=0;
                break;
          case _ShiftEnter:
                Find(Pat,pos+1);
                c=0;
                break;
          case _Up:
          case _Left:
                *Pat=0;
                if (pos>0)
                {       pos--;
                        if (offs>pos) offs--;
                        ReDraw();
                }
                c=0;
                break;
          case _Down:
          case _Right:
                *Pat=0;
                if (pos<size-1)
                {       pos++;
                        if (offs+B.Y-A.Y-1<pos) offs++;
                        ReDraw();
                }
                c=0;
                break;
          case _PgUp:
                *Pat=0;
                pos-=(B.Y-A.Y);
                offs-=(B.Y-A.Y);
                if (pos<0) pos=0;
                if (offs<0) offs=0;
                ReDraw();
                c=0;
                break;
          case _PgDn:
                *Pat=0;
                pos+=(B.Y-A.Y);
                if (pos>size-1) pos=size-1;
                while (pos>offs+(B.Y-A.Y-1)) offs++;
                if (offs<0) offs=0;
                ReDraw();
                c=0;
                break;
          case _Home:
                *Pat=0;
                pos=offs=0;
                ReDraw();
                c=0;
                break;
          case _End:
                *Pat=0;
                pos=size-1;
                offs=pos-(B.Y-A.Y-1);
                if (offs<0) offs=0;
                ReDraw();
                c=0;
                break;
          case _Enter:
                *Pat=0;
                return cmYes;
        }
        return View::Handle(c);
} //FileList::Handle

#ifdef __MSDOS__
static struct ffblk ff;
static int ffirst (char *path, char *name, int &isdir)
{  char Pat[256];
   strcpy(Pat,path);
   strcat(Pat,"*.*");
   int done=findfirst(Pat,&ff,FA_DIREC);
   if (!done)
   { strcpy(name,ff.ff_name);
     isdir=((ff.ff_attrib&FA_DIREC)!=0);
   }
   return done;
}

static int ffnext (char *name, int &isdir)
{  int done=findnext(&ff);
   if (!done)
   { strcpy(name,ff.ff_name);
     isdir=((ff.ff_attrib&FA_DIREC)!=0);
   }
   return done;
}

static void ffclose()
{}
#else
static DIR *dir;
static char _path[256];

static int ffnext (char *name, int &isdir)
{ struct dirent *d;
  char n[256];
        d=readdir(dir);
        if (d==NULL) return 1;
        strcpy(name,d->d_name);
        struct stat sb;
        strcpy(n,_path);
        strcat(n,name);
        stat(n,&sb);
        isdir=(sb.st_mode&S_IFDIR)!=0;
        return 0;
}

static int ffirst (char *path, char *name, int &isdir)
{       strcpy(_path,path);
        if (*path==0)
                dir=opendir("./");
        else    dir=opendir(path);
        if (dir==NULL) return 1;
        return ffnext(name,isdir);
}

static void ffclose()
{       if (dir) closedir(dir);
}
#endif

static void Add (Line *&First, Line *&Last, Line *ptr)
{       if (First==NULL)
                First=Last=ptr;
        else if (StrCmp(ptr->Text,"../")==0)
        {       ptr->Next=First->Next;
                if (First->Next) First->Next->Prev=ptr;
                First=ptr;
        }
        else
        { Line *p;
                for (p=First; p; p=p->Next)
                {       if ((StrCmp(p->Text,"../")==0) ||
                                (StrCmp(p->Text,ptr->Text)<0)) continue;
                        ptr->Next=p;
                        ptr->Prev=p->Prev;
                        if (p->Prev) p->Prev->Next=ptr;
                        p->Prev=ptr;
                        if (p==First) First=ptr;
                        return;
                }
                ptr->Prev=Last;
                Last->Next=ptr;
                Last=ptr;
        }
} //Add

int match (char *name, char *Pat)
{       while (*Pat)
          switch (*Pat)
          { case '?':
                Pat++;
                if (*name) name++;
                else return 0;
                break;
            case '*':
                Pat++;
                if (*Pat==0) return 1;
                while (*name)
                     if (match(name++,Pat)) return 1;
                return 0;
            case '\\':
                Pat++;
            default:
#ifdef __MSDOS__
                if (tolower(*name++)!=tolower(*Pat++)) return 0;
#else
                if (*name++!=*Pat++) return 0;
#endif
          }
        if (*name==0)   return 1;
        else return 0;
} //match

int getDir (char *pat, Line *&ptr)
{ char name[80];
  char Pat[80];
  char path[256];
  int isdir,done;
  Line *First,*Last;
  Line *First2,*Last2;

        while (ptr)
        { Line *p=ptr->Next;
                delete ptr;
                ptr=p;
        }

        char *pp=pat+StrLen(pat);
        while (pp>pat)
        {       if (pp[-1]=='/') break;
                pp--;
        }
        strcpy(Pat,pp);
        char c= *pp;
        *pp=0;
        strcpy(path,pat);
        *pp=c;
        if (Pat[0]==0) strcpy(Pat,"*");

        First=Last=First2=Last2=NULL;
        for (done=ffirst(path,name,isdir); !done; done=ffnext(name,isdir))
        {       if (isdir) strcat (name,"/");
                if (StrCmp(name,"./")==0) continue;
                else if (isdir)
                        Add(First,Last,CreateLine(name));
                else if (match(name,Pat))
                        Add(First2,Last2,CreateLine(name));
        }
        ffclose();
        if (Last) Last->Next=First2;
        if (First2) First2->Prev=Last;
        if (Last2) Last=Last2;
        if (First==NULL) First=First2;
        ptr=First;
        return 1;
} //getDir

void superdir (char *dir)
{ char *p;
        if (StrCmp(dir,"/")==0) return;
        if (*dir==0)
        { strcat(dir,"../");
          return;
        }
        p=dir+StrLen(dir);
        if ((p<=dir)||(p[-1]!='/')) return;
        --p;
        while (p>dir)
        {       if (p[-1]=='/') break;
                --p;
        }
        if (StrCmp(p,"../")!=0)
                *p=0;
        else    strcat(p,"../");
} //superdir

unsigned GetNewName (char *name)
{ static char buf[256];
  static char oldbuf[256];
  unsigned res;
  unsigned t;

  Dialog D(Rect(40,12),"Open file",1);
  FileList *F;
  InputLine *L;
  Line *DIR=NULL;
        strcpy(buf,oldbuf);
        D.Insert(new StaticText(Rect(2,1,10,2),"Name:"));
        D.Insert(L=new InputLine(Rect(2,2,38,3),"",'N',buf,sizeof(buf)));
        D.Insert(new StaticText(Rect(2,3,10,4),"Files:"));
        D.Insert(F=new FileList(Rect(2,4,38,11),&DIR,'F'));
        D.SelectNext();
        char **p=showkeybar(dlgkeys);
ree:    getDir(buf,DIR);
        strcpy(oldbuf,buf);
        res=D.Exec();
        if (res==cmYes)         //   FileList
        { char *pp;
          char tmp[40];
                pp=strrchr(buf,'/');
                if (pp) pp++;
                else pp=buf;
                F->getLine(tmp);
                if (strchr(tmp,'/'))    // 
                { char tmp2[40];
                        strncpy(tmp2,pp,sizeof(tmp2));
                        *pp=0;
                        if (StrCmp(tmp,"../")==0)
                                superdir(buf);
                        else    strncat(buf,tmp,sizeof(buf)-StrLen(buf)-1);
                        strncat(buf,tmp2,sizeof(buf)-StrLen(buf)-1);
                        F->pos=F->offs=0;
                        D.SelectNext();
                        L->Handle(t=_End);
                        goto ree;
                }
                else                    // 
                {       *pp=0;
                        strncat(buf,tmp,sizeof(buf)-StrLen(buf)-1);
                }
                res=cmOK;
        }
        else if (res==cmOK)     //   InputLine
        {       if ((*buf==0)||strchr(buf,'*')||strchr(buf,'?')||
                        strchr(buf,'\\'))
                {       F->pos=F->offs=0;
                        D.SelectNext();
                        goto ree;
                }
                if (buf[StrLen(buf)-1]=='/')
                {       F->pos=F->offs=0;
                        D.SelectNext();
                        goto ree;
                }
        }
        if (buf[0]==0) res=cmCancel;
        if (res==cmOK)
        {       strcpy(name,buf);
                struct stat statbuf;
                if (stat(name, &statbuf)<0)
                {       if (cmYes==NoFile(name))
                                return cmOK;
                        else    return cmCancel;
                }
                else if (statbuf.st_mode & S_IFDIR)
                {       if (buf[StrLen(buf)-1]!='/') strcat(buf,"/");
                        L->Handle(t=_End);
                        F->pos=F->offs=0;
                        D.SelectNext();
                        goto ree;
                }
                else if (!(statbuf.st_mode & S_IREAD))
                {       OpenErr(name);
                        res=cmCancel;
                }
        }
        showkeybar(p);
        return res;
} //GetNewName

