/*
 *   
 */

#include "head.h"

#ifndef __MSDOS__
#include <unistd.h>
#ifdef REGEXP
#include <regex.h>
#endif
#endif

extern void makeswap();
extern unsigned fast;
extern int delimiter (char c);
extern void scrsize();
extern int sigs;

static char lbuf[MAXSTR+1];
char rmode[]="r";
char wmode[]="w";

VStr *Buf;
int Vert;       //  
int trig=1;

int zoom=0;
static int indexx;
int wcnt=0;

extern KeyBar *Key;

void EWindow::VFrame (int flag)
{ if (F==NULL) return;
  if (E==NULL) return;
  F->Insert(new ParamText(Rect(0,0,2,1),"%1s",_Arrow_,&State));
  F->Insert(new ParamText(Rect(3,0,B.X-50,1),"View: %-16s",_Str_,E->Name));
  if (flag)
   F->Insert(new ParamText(Rect(B.X-49,0,B.X-30,1),"Lines: ???",_Str_,0));
  else
   F->Insert(new ParamText(Rect(B.X-49,0,B.X-30,1),"Lines: %ld",_Lines_,&E->Lines));
  F->Insert(new ParamText(Rect(B.X-29,0,B.X-10,1),"Line: %d",_Num_,&E->Lineno));
  F->Insert(new ParamText(Rect(B.X-9,0,B.X,1),"Col: %d",_Num_1,&E->xoffset));
} //VFrame

void EWindow::EFrame (int flag)
{ if (F==NULL) return;
  if (E==NULL) return;
  F->Insert(new ParamText(Rect(0,0,1,1),"%1s",_Arrow_,&State));
  F->Insert(new ParamText(Rect(1,0,2,1),"%1s",_Star_,&E->changed));
  F->Insert(new ParamText(Rect(3,0,B.X-55,1),"File: %-16s",_Str_,E->Name));
  F->Insert(new ParamText(Rect(B.X-54,0,B.X-50,1),"%3s",_Rus_,&RUS));
  F->Insert(new ParamText(Rect(B.X-49,0,B.X-46,1),"%3s",_Ins_,&ins));
  F->Insert(new ParamText(Rect(B.X-45,0,B.X-45,1),"%1s",_Star_,&define));
  if (flag)
   F->Insert(new ParamText(Rect(B.X-44,0,B.X-32,1),"Lines: ???",_Str_,0));
  else
   F->Insert(new ParamText(Rect(B.X-44,0,B.X-32,1),"Lines: %ld",_Lines_,&E->Lines));
  F->Insert(new ParamText(Rect(B.X-31,0,B.X-20,1),"Line: %d",_Num_,&E->Lineno));
  F->Insert(new ParamText(Rect(B.X-19,0,B.X-10,1),"Col: %d",_Num_1,&E->xpos));
  F->Insert(new ParamText(Rect(B.X-9,0,B.X,1),"Char: %d",_Num_,&E->Curchar));
} //EFrame

void EWindow::NewFrame()
{ if (F==NULL) return;
  while (F->Remove(F->First));
  if (view) VFrame(E->GapCnt);
  else      EFrame(E->GapCnt);
}

//   
EWindow::EWindow (const Rect &R, char *name,
        int line, int x, int y, int xoffs, int hide,
                int *markx, int *marky):
                Group(R),Zoom(R)
{ wcnt++; status=0;
  if (zoom) { A.X=0; A.Y=0; B.X=SWIDTH; B.Y=SHIGHT-1; }
  if (hide||zoom) Hide();

  Rect RR(0,1,SWIDTH,B.Y-A.Y);

  E=new Edit(RR);
  F=new Frame(Rect(0,0,SWIDTH,1));

  Insert(F);
  Insert(E);
  int res=E->getfile(name);
  if (view) VFrame(E->GapCnt);
  else      EFrame(E->GapCnt);

  status=res;

  if (res<0)
        return;
  else if (res==0)
  {     OpenErr(name);
        return;
  }
  if (line<1) return;
  int n;
  VStr *p;

  for (p=E->First,n=1; p; p=E->GetNext(p),n++)
  {     if (marky)
        for (int j=0; j<10; j++)        //   
        {       if (marky[j]==n)
                {       E->MarkPosY[j]=p;
                        E->MarkPosX[j]=markx[j];
                }
        }
        if (n==line)    // .  
        {       E->Lineno=n;
                E->Cur=p;
        }
  }

  E->xpos=x;
  E->xoffset=xoffs;
  for (n=0, E->Scr=E->Cur; (E->Scr->Prev)&&(n<y); n++)
        E->Scr=E->Scr->Prev;
  E->ypos=n;
} //EWindow::EWindow

EWindow::~EWindow()
{ wcnt--; }

void EWindow::Assign (int AX,int AY,int BX,int BY)
{       Group::Assign(AX,AY,BX,BY);
        Current->Assign(0,1,BX-AX,BY-AY);
} //EWindow::Assign

unsigned EWindow::Handle (unsigned &c)
{       if (c==cmReSize)
        {       Zoom.Assign(0,indexx*SHIGHT/wcnt,SWIDTH,(indexx+1)*SHIGHT/wcnt-1);
                if (!zoom) Assign(Zoom.A.X,Zoom.A.Y,Zoom.B.X,Zoom.B.Y);
                else Assign(0,0,SWIDTH,SHIGHT-1);
                NewFrame();
        }
        indexx++;
        return Group::Handle(c);
} //EWindow::Handle

Edit::Edit (Rect R):View(R)
{       ypos=xpos=oldx=oldy=0;
        yy=xx= -1;
        xoffset=oldxoffs=0;
        GapCnt=0;
        First=Last=Cur=Scr=NULL;
        F=NULL;
        vert=0;
        Lines=0;
        Lineno=1;
        Curchar=0;
        changed=hasbak=0;
        Name[0]=0;
        Mbeg=Mfin=0;
        for (int i=0; i<10; i++) MarkPosY[i]=NULL,MarkPosX[i]=0;
        MarkBlk=NULL;
        UndoBuf=new undo_b;
} //Edit::Edit

Edit::~Edit()
{       if (wcnt>0)
        while (First)
        {       VStr *p=First->Next;
                DisposeVStr(First);
                First=p;
        }
        if (F!=NULL) fclose(F);
        if (hasbak && !Bak)
        { char N[256];
                strcpy(N,Name);
                strcat(N,".b");
                remove(N);
        }
        delete UndoBuf;
} //Edit::~Edit

void Edit::Assign (int AX,int AY,int BX,int BY)
{       View::Assign(AX,AY,BX,BY);
        if (ypos>(B.Y-A.Y)) ypos=(B.Y-A.Y);
        int i;
        for (Scr=Cur ,i=ypos; i>0; Scr=GetPrev(Scr), i--);
} //Edit::Assign

int Edit::Color (int cnum)
{       switch (cnum)
        { case 0:
                return View::Color(7);
          default:
                return View::Color(cnum);
        }
} //Edit::Color

//     f   lbuf
int ReadLine (FILE *f)
{ int c;
        for (int i=0; i<MAXSTR; i++)            //  
        {   c=fgetc(f);
            if (feof(f)||(c==012))
            {   lbuf[i]=0;
                break;
            }
            if (c=='Z'-0100)
            {   lbuf[i++]=c;
                lbuf[i]=0;
                break;
            }
            lbuf[i]=c;
        } //for
        lbuf[MAXSTR]=0;
        return c;
} //ReadLine

//    
int Edit::getfile (char *name)
{ int res=1;
  struct stat statbuf;
        strncpy(Name,name,sizeof(Name)-1);
        if (name[0]==0) F=stdin;
        else F=fopen(name,rmode);
        if (F==NULL)
        {       Cur=Scr=First=Last=NewVStr();
                Last->Next=NewVStr();
                Last->Next->Prev=Last;
                if (errno==EACCES)
                        return 0;
                else    return 1;
        }
        fstat(fileno(F), &statbuf);
        int REG=statbuf.st_mode & S_IFREG;
        setwait(0);
        First=Last=Cur=Scr=NULL;
        while (!feof(F))
        {   long Pos=ftell(F);
            if (ReadLine(F)=='Z'-100) break;
            Lines++;
            VStr *p;
            if (!REG)
                 p=NewVStr(lbuf);
            else p=SetVStr(F,Pos,Lines<MaxResCount?lbuf:NULL);
            p->Prev=Last;
            if (Last==NULL)
                 First=p;
            else Last->Next=p;
            Last=p;
            if (REG&&(Lines>=MaxCount)) //  ""
            { GapStr *Gap= new GapStr(F);
                Gap->Prev=Last;
                Last->Next=Gap;
                Gap->A=ftell(F);
                fseek(F,0L,SEEK_END);
                BackRead(F,lbuf);       //  
                Gap->B=ftell(F);
                p=SetVStr(F,Gap->B+LFsize,lbuf);
                p->Prev=Gap;
                Gap->Next=p;
                if (Gap->B<=Gap->A)     //
                {       p->Prev=Last;
                        Last->Next=p;
                        DisposeVStr(Gap);
                }
                Last=p;
                ++GapCnt;
                ++Lines;
                break;
            }
            if (CtrlBreak()) { res= -1; break; }
        } //while
        Cur=Scr=First;
        Last->Next=NewVStr();
        Last->Next->Prev=Last;
        setwait(1);
        return res;
} //Edit::getfile

//   
int Edit::loadexec (char *command)
{       if (command==NULL) return 1;
        if (command[0]==0) return 1;
        strcat(command," 2>&1");
#ifndef __MSDOS__
        FILE *f=popen(command,rmode);
        if (f==NULL) return 0;
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        while (!feof(f)&&(ReadLine(f)!='Z'-100))
        {   VStr *p=NewVStr(lbuf);
            p->Prev=Cur->Prev;
            p->Next=Cur;
            if (Scr==Cur) Scr=p;
            if (First==Cur) First=p;
            if (Cur->Prev) Cur->Prev->Next=p;
            Cur->Prev=p;
            UndoBuf->put(undo_el(INS,NULL,p->Next,oldx,Lineno,Lines));
            Lines++; ypos++;
            if (Lineno>=0) Lineno++;
            if (ypos>(B.Y-A.Y))
            {   ypos--;
                Scr=Scr->Next;
            }
        } //while
        pclose(f);
        changed=1;
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
#endif
        return 1;
} //Edit::loadexec

//  
int Edit::loadfile (char *name)
{       if (name==NULL) return 1;
        if (name[0]==0) return 1;
        FILE *f=fopen(name,rmode);
        if (f==NULL) return 0;
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        while (!feof(f)&&(ReadLine(f)!='Z'-100))
        {   VStr *p=NewVStr(lbuf);
            p->Prev=Cur->Prev;
            p->Next=Cur;
            if (Scr==Cur) Scr=p;
            if (First==Cur) First=p;
            if (Cur->Prev) Cur->Prev->Next=p;
            Cur->Prev=p;
            UndoBuf->put(undo_el(INS,NULL,p->Next,oldx,Lineno,Lines));
            Lines++; ypos++;
            if (Lineno>=0) Lineno++;
            if (ypos>(B.Y-A.Y))
            {   ypos--;
                Scr=Scr->Next;
            }
        } //while
        fclose(f);
        changed=1;
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
        return 1;
} //Edit::loadfile

//    
int Edit::storefile (char *name, VStr *AA, VStr *BB)
{ VStr *p;
  char buf[MAXSTR+1];
        if (name==NULL) return 1;
        if (name[0]==0) return 1;
        FILE *f=fopen(name,wmode);
        if (f==NULL)
        {       WriteErr(name);
                return 0;
        }
        if (comp(AA,BB)>0) { VStr *t=AA; AA=BB; BB=t;}
        for (p=AA; p!=BB; p=GetNext(p))
        {       if (vert)
                        copycol(Mbeg,Mfin,GetVStr(p),buf);
                else    strncpy(buf,GetVStr(p),MAXSTR);
                fprintf(f,"%s\n",buf);
        }
        if (vert)
                copycol(Mbeg,Mfin,GetVStr(p),buf);
        else    strncpy(buf,GetVStr(p),MAXSTR);
        fprintf(f,"%s",buf);
        fclose(f);
        return 1;
} //Edit::storefile

//       NAME.b
void Edit::makecopy()
{ struct stat sbuf;
        if (hasbak) return;
        FILE *in=fopen(Name,rmode);
        if (in==NULL) return;
        char name[256];
        strcpy(name,Name);
        strcat(name,".b");
        FILE *out=fopen(name,wmode);
        if (out==NULL) return;
        char buf[512];
        int cnt;
        for (;;)
        {       cnt=fread(buf,1,sizeof(buf),in);
                if (cnt<=0) break;
                fwrite(buf,1,cnt,out);
        }
        fclose(in); fclose(out);
        if (stat (Name, &sbuf)<0)
                chmod (name, 0600);     // .b  rw   
        else
        {
#ifndef __MSDOS__
                chown (name, sbuf.st_uid, sbuf.st_gid);
#endif
                chmod (name, sbuf.st_mode);
        }
        freopen(name,"rw",F);
} //Edit::makecopy

//      f
void Edit::tofile (FILE *f)
{ VStr *p;
        WaitMsg();
        for (p=First; p!=Last; p=p->Next)
        {       if (!p->isGap)
                        fprintf(f,"%s\n",GetVStr(p));
                else    // ""    
                {       char buf;
                        GapStr *Gap=(GapStr*)p;
                        fseek(F,Gap->A,SEEK_SET);
                        while (ftell(F)<=Gap->B)
                        {       if (fread(&buf,1,1,F)<=0) break;
                                fwrite(&buf,1,1,f);
                        }
                }
        }
        fprintf(f,"%s",GetVStr(p));
        if (f!=stdout) fclose(f);
        changed=0;
} //Edit::tofile

//   
int Edit::putfile (char *name)
{ FILE *f;
  struct stat sbuf;
  int flag=0;
  int uid = -1;
  char N[256],NN[256];
        if (name==NULL) name=Name;

        if (name[0]==0)
                f=stdout;
        else if (strcmp(Name,name))
                f=fopen(name,wmode);
        else if (hasbak)
                f=fopen(name,wmode);
        else if (stat(name, &sbuf)<0)
        {       makecopy();
                f=fopen(name,wmode);
        }
        else
        {
#ifndef __MSDOS__
                uid=getuid();
#endif
                if (fast&&((uid==0)||(uid==sbuf.st_uid)))
                {       strcpy(N,name);
                        strcat(N,".n");
                        f=fopen(N,wmode);
                        flag=1;
                }
                else
                {       makecopy();
                        f=fopen(name,wmode);
                }
        }

        if (f==NULL)
        {       if (cmCancel==WriteErr(name)) return 0;
                strcpy(N,name);
                if (cmCancel==GetName(N)) return 0;
                tofile(fopen(N,wmode));
                return 0;
        }
        if (name!=Name) strncpy(Name,name,sizeof(Name));
        tofile(f);      //   f
        if (flag)
        {       if (!hasbak)
                {       strcpy(NN,Name);
                        strcat(NN,".b");
                        rename(Name,NN);
                        freopen(NN,"rw",F);
                }
                rename(N,name);
#ifndef __MSDOS__
                chown (name, sbuf.st_uid, sbuf.st_gid);
#endif
                chmod (name, sbuf.st_mode);
        }
        hasbak=1;
        return 1;
} //Edit::putfile

//     "name"
int Edit::closefile (char *name)
{       if (!putfile(name)) return 0;
        if (F!=NULL) fclose(F);
        if (hasbak && !Bak)
        { char N[256];
                strcpy(N,Name);
                strcat(N,".b");
                remove(N);
        }
        return 1;
} //Edit::closefile

//      
VStr *Edit::getlowline()
{ int i;
  VStr *p;
        for (i=0,p=Scr; (i<(B.Y-A.Y))&&(p!=Last); i++) p=GetNext(p);
        if (i<(B.Y-A.Y)) return NULL;
        return p;
}

void EWindow::SetState (int Stat)
{       if (State!=Stat)
        {       State=Stat;
                if (State&&zoom) DrawView();
        }
} //EWindow::SetState

//    
void Edit::Draw ()
{ int i;
  VStr *p;
        //corrxoffs();
        frame();
        for (i=0,p=Scr; (i<=(B.Y-A.Y))&&(p!=NULL); i++,p=GetNext(p))
            sout(0,i+A.Y,GetVStr(p),p==Last,belong(Cur,MarkBlk,p,vert));
        for (; i<=(B.Y-A.Y); i++)
        {       curxy(0,i+A.Y);
                Color(0);
                clreol();
        }
} //Draw

//     (Dirty)
void Edit::ReDraw ()
{ int i;
  VStr *p;
  Rect R=getCoord();
        if (!Owner) return;
        if (!Owner->Visual()) return;
        for (i=0,p=Scr; (i<=(B.Y-A.Y))&&(p!=NULL); i++,p=GetNext(p))
            if ((Dirty.A.Y<=(i+R.A.Y))&&((i+R.A.Y)<=Dirty.B.Y))
                sout(Dirty.A.X,i+A.Y,GetVStr(p),p==Last,belong(Cur,MarkBlk,p,vert),Dirty.B.X);
        for (; i<=(B.Y-A.Y); i++)
            if ((Dirty.A.Y<=(i+R.A.Y))&&((i+R.A.Y)<=Dirty.B.Y))
            {   curxy(0,i+A.Y);
                Color(0);
                clreol();
            }
        frame();
} //ReDraw

//    ( .   )
void Edit::drawhalf (int offs)
{ int i;
  VStr *p;
        if (!State&&(Options&ofHidden)) return;
        for (i=0,p=Scr; (i<=(B.Y-A.Y))&&(p!=NULL); i++,p=GetNext(p))
            if (i>=offs) sout(0,i+A.Y,GetVStr(p),p==Last,belong(Cur,MarkBlk,p,vert));
        for (; i<=(B.Y-A.Y); i++)
        {       curxy(0,i+A.Y);
                Color(0);
                clreol();
        }
        frame();
        return;
} //drawhalf

static unsigned t;

//     
void Refresh()
{       App->Handle(t=cmReDraw);
        Dirty.Assign(1000,1000,0,0);
        App->DrawView();
} //Refresh

void Edit::corrxoffs()
{       while (xpos-xoffset>=SWIDTH)
            xoffset+=8;
        while ((xpos<=xoffset)&&(xoffset>0))
            xoffset-=8;
} //Edit::corrxoffs

//    Lin    
int Edit::calcy (VStr *Lin)
{ VStr *p;
  int i;
        for (p=Scr,i=0; GetNext(p) && (i<(B.Y-A.Y)); p=GetNext(p), i++)
                if (p==Lin) return i;
        return -1;
} //Edit::calcy

//   s1  s2    s1
static int strcomp (const char *s1, const char *s2)
{       while ((*s2)&&(*s1==*s2)) s1++,s2++;
        if (*s2==0) return 1;
        return 0;
}

//   s1  s2    s1    
static int _strcomp (const char *s1, const char *s2)
{       while ((*s2)&&(toupper(*s1)==toupper(*s2))) s1++,s2++;
        if (*s2==0) return 1;
        return 0;
}

//   s2   s1
static char *strsearch (char *s1, const char *s2)
{       while (*s1&&!strcomp(s1,s2)) s1++;
        if (*s1==0) return NULL;
        return s1;
} //strsearch

//   s2   s1; len= 
static char *srch (char *s1, const char *s2, int& len, unsigned Reg)
{
  char *res=0;
#ifndef __MSDOS__
        if (!Reg)
#endif
        {       len=StrLen(s2);
                return strsearch(s1,s2);
        }
#ifdef REGEXP
  regex_t preg;
  regmatch_t pmatch;
        len=0;
        if (regcomp(&preg,s2,REG_EXTENDED/* | REG_ICASE*/))
                return NULL;
        else if (!regexec(&preg,s1,1,&pmatch,0))
        {       res=s1+pmatch.rm_so;
                len=pmatch.rm_eo-pmatch.rm_so;
        }
        regfree(&preg);
#endif
        return res;
} //srch

void StrUp (char *p)
{       for (; *p; p++)
        {       if ((unsigned)*p<127)
                        *p=toupper(*p);
                else    *p=*p&~040;
        }
} //StrUp

//   (  ,  ,  0)
int Edit::Search (char *text,
        unsigned Case, unsigned Word, unsigned FromTop, unsigned Reg,
        unsigned Back, unsigned first)
{       if (!Back) return ForwSearch(text,Case,Word,FromTop,Reg,first);
        else      return BackSearch(text,Case,Word,FromTop,Reg,first);
} // Edit::Search

//    (  ,  ,  0)
int Edit::ForwSearch (char *text,
        unsigned Case, unsigned Word, unsigned FromTop, unsigned Reg,
        unsigned first)
{ VStr *Lin,*Beg;
  char *pp;
  char patt[80];
  char line[MAXSTR+1];
  int n,ny,flag,len,res;

    res=-1;
    if (!first) FromTop=0;
    if (FromTop)
    { Beg=First; n=1; }
    else if (!view)
    { Beg=Cur; n=Lineno; }
    else
    { int i;
      Beg=Cur;
      for (i=0; i<yy ;i++, Beg=GetNext(Beg));
      n=Lineno;
    }
    ny=Lineno-ypos;     //     
    flag=0;
    strncpy(patt,text,sizeof(patt));
    if (!Case) StrUp(patt);
    setwait(0);
    for (Lin=Beg; GetNext(Lin); Lin=GetNext(Lin), n++)
    {   if (!first&&!flag&&((n<ny)||(n>=ny+(B.Y-A.Y))))
        {       flag=1;
                SearchingMsg();
        }
        strcpy(line,GetVStr(Lin));
        char *tmp=line;
        int x0=0;
        if (!Case) StrUp(line);
retry:  pp=srch(tmp,patt,len,Reg);
        if (pp)
        {   x0=getpos(line,pp);
            char c=pp[len];
            char cc=(pp==line?0:pp[-1]);
            if ((Lin==Beg)&&(x0<=xpos) || Word && !(delimiter(c)&&delimiter(cc)))
            /*(isalnum(c)||isalnum(cc)))*/
            {   tmp=pp+1;
                goto retry;
            }
            xpos=x0;
            corrxoffs();

            if (!view) Lineno=n;
            int offy=calcy(Lin);
            if (offy<0)
            {   Scr=Cur=Lin;
                ypos=0;
                Lineno=n;
                App->DrawView();
            }
            else if (oldxoffs!=xoffset)
            {   if (!view) Cur=Lin;
                ypos=offy;
                App->DrawView();
                oldxoffs=xoffset;
            }
            else
            {   if (!view) Cur=Lin;
                ypos=offy;
            }
            yy=ypos; xx=xpos;
            res=len;
            break;
        }
        if (CtrlBreak()) break;
    } //for Lin
    setwait(1);
    return res;
} //Edit::ForwSearch

//    (  ,  ,  0)
int Edit::BackSearch (char *text,
        unsigned Case, unsigned Word, unsigned FromTop, unsigned Reg,
        unsigned first)
{ VStr *Lin,*Beg;
  char *pp;
  char patt[80];
  char line[MAXSTR+1];
  int n,ny,flag,len,res;

    res=-1;
    if (!first) FromTop=0;
    if (FromTop)
    { Beg=Last; n=Lines; }
    else if (!view)
    { Beg=Cur; n=Lineno; }
    else
    { int i;
      Beg=Cur;
      for (i=0; i<yy ;i++, Beg=GetNext(Beg));
      n=Lineno;
    }
    ny=Lineno-ypos;     //     
    flag=0;
    strncpy(patt,text,sizeof(patt));
    if (!Case) StrUp(patt);
    setwait(0);
    for (Lin=Beg; Lin; Lin=GetPrev(Lin), n--)
    {   if (!first&&!flag&&((n<ny)||(n>=ny+(B.Y-A.Y))))
        {       flag=1;
                SearchingMsg();
        }
        strcpy(line,GetVStr(Lin));
        char *tmp=line;
        int x0=0;
        if (!Case) StrUp(line);
retry:  pp=srch(tmp,patt,len,Reg);
        if (pp)
        {   x0=getpos(line,pp);
            char c=pp[len];
            char cc=(pp==line?0:pp[-1]);
            if ((Lin==Beg)&&(x0<=xpos) || Word && (isalnum(c)||isalnum(cc)))
            {   tmp=pp+1;
                goto retry;
            }
            xpos=x0;
            corrxoffs();

            if (!view) Lineno=n;
            int offy=calcy(Lin);
            if (offy<0)
            {   Scr=Cur=Lin;
                ypos=0;
                Lineno=n;
                App->DrawView();
            }
            else if (oldxoffs!=xoffset)
            {   if (!view) Cur=Lin;
                ypos=offy;
                App->DrawView();
                oldxoffs=xoffset;
            }
            else
            {   if (!view) Cur=Lin;
                ypos=offy;
            }
            yy=ypos; xx=xpos;
            res=len;
            break;
        }
        if (CtrlBreak()) break;
    } //for Lin
    setwait(1);
    return res;
} //Edit::BackSearch

//  str  &  rep
static char *expand (char *str, int len, char *rep)
{ static char buf[MAXSTR+1];
  char *p, *pp, *q;
        for (p=rep, pp=buf; *p; p++,pp++)
        {       if (*p=='\\')
                        *pp = *++p;
                else if (*p=='&')
                {       for (q=str; *q && (q-str<len); q++)
                                *pp++ = *q;
                        pp--;
                }
                else    *pp = *p;
        }
        *pp=0;
        return buf;
} //expand

//    str   len  rep   x
static void strrepl (int x, char *str, int len, char *rep)
{       int i;
        int offs=StrLen(rep)-len;
        if (offs>0)
                for (i=StrLen(str); i>=x; i--)
                        str[i+offs]=str[i];
        else    for (i=x; i<=StrLen(str); i++)
                        str[i]=str[i-offs];
        for (i=x; rep[i-x]; i++)
                str[i]=rep[i-x];
} //strrepl

//   
int Edit::SearchRepl (char *text, char *repl,
                unsigned Case, unsigned Word, unsigned FromTop,
                unsigned All, unsigned Prompt, unsigned Reg,
                unsigned first)
{ Rect R=getCoord();
  unsigned res=cmYes;
  char buf[MAXSTR+1];
  char *prepl;
  int _len;
  do {  _len=Search(text,Case,Word,FromTop,Reg,0,first);
        if (_len<0) return -1;
        first=0;
        if (!Prompt)
                res=cmYes;
        else
        {       Refresh();
                res=RepDlg(R.A.X+xpos-xoffset,R.A.Y+ypos);
        }
        switch (res)
        { case cmNo:
                break;
          case cmOK:
                All=1;
                Prompt=0;
          case cmYes:
                strncpy(buf,GetVStr(Cur),sizeof(buf));
                prepl=repl;
                if (Reg) prepl=expand(buf+strpos(xpos,buf),_len,repl);
                strrepl(strpos(xpos,buf),buf,_len,prepl);
                RepTxt(Cur,buf);
                xpos+=len(prepl);
                corrxoffs();
                sout(0,ypos+A.Y,GetVStr(Cur),Cur==Last,belong(Cur,MarkBlk,Cur,vert));
                changed=1;
                break;
          case cmCancel:
          default:
                return 1;
        }
  } while (All);
  return 1;
} //Edit::SearchRepl

int matchword (int x, char *line, char *patt)
{ int len=StrLen(patt);
  int xx=strpos(x,line);
        while((xx>=0)&&len&&!_strcomp(line+xx,patt)) xx--,len--;
        if (!_strcomp(line+xx,patt)) return 0;
        if (!isalnum(patt[0])) return 1;
        int res=!isalnum(line[xx+StrLen(patt)]);
        if (xx>0) res=res&&!isalnum(line[xx-1]);
        return res;
} //matchword

int wordcomp (int xx, char *line, char *patt)
{       if (!_strcomp(line+xx,patt)) return 0;
        if (!isalnum(patt[0])) return 1;
        int res=!isalnum(line[xx+StrLen(patt)]);
        if (xx>0) res=res&&!isalnum(line[xx-1]);
        return res;
} //wordcomp

//    
int Edit::BrackF (char *left, char *right)
{ VStr *Lin;
  int n,cnt,x0=0;

    if (view) return 0;
    for (Lin=Cur, cnt=0, n=Lineno; GetNext(Lin); Lin=GetNext(Lin), n++)
    {   char *line=GetVStr(Lin);
        int k=0;
retry:  while (line[k]&&!wordcomp(k,line,left)&&!wordcomp(k,line,right)) k++;
        if (line[k]==0) continue;

        x0=getpos(line,line+k);
        if ((Lin==Cur)&&(x0<=xpos))
        { k++; goto retry; }

        if (wordcomp(k,line,right)) cnt--;
        else if (wordcomp(k,line,left)) cnt++;
        if (cnt>=0) { k++; goto retry;}
        break;
    }

    if (GetNext(Lin)==NULL) return 0;
    xpos=x0;
    corrxoffs();
    Lineno=n;
    int offy=calcy(Lin);
    if (offy<0)
    {   Scr=Cur=Lin;
        ypos=0;
        Lineno=n;
        DrawView();
    }
    else if (oldxoffs!=xoffset)
    {   Cur=Lin;
        ypos=offy;
        DrawView();
        oldxoffs=xoffset;
    }
    else
    {   Cur=Lin;
        ypos=offy;
    }
    yy=ypos; xx=xpos;
    return 1;
} //Edit::BrackF

//    
int Edit::BrackB (char *left, char *right)
{ VStr *Lin;
  int n,cnt,x0=0;

    if (view) return 0;
    for (Lin=Cur, cnt=0, n=Lineno; Lin; Lin=GetPrev(Lin), n--)
    {   char *line=GetVStr(Lin);
        int k=StrLen(line);
retry:  while ((k>=0)&&!wordcomp(k,line,left)&&!wordcomp(k,line,right)) k--;
        if (k<0) continue;

        x0=getpos(line,line+k);
        int offs=StrLen(right);
        if (offs==1) offs=0;
        if ((Lin==Cur)&&(x0+offs>=xpos))
        { k--; goto retry; }

        if (wordcomp(k,line,left)) cnt--;
        else if (wordcomp(k,line,right)) cnt++;
        if (cnt>=0) { k--; goto retry;}
        break;
    }

    if (Lin==NULL) return 0;

    xpos=x0;
    corrxoffs();
    Lineno=n;
    int offy=calcy(Lin);
    if (offy<0)
    {   Scr=Cur=Lin;
        ypos=0;
        Lineno=n;
        DrawView();
    }
    else if (oldxoffs!=xoffset)
    {   Cur=Lin;
        ypos=offy;
        DrawView();
        oldxoffs=xoffset;
    }
    else
    {   Cur=Lin;
        ypos=offy;
    }
    yy=ypos; xx=xpos;
    return 1;
} //Edit::BrackB

//    num
void Edit::GotoLine (int num)
{ VStr *Lin;
  int n;
    if (num==0) return;
    if (num<0)  //  
    {   for (Lin=Last,n= -1; Lin!=First; Lin=GetPrev(Lin),n--)
                if (n==num) break;
        if (!GapCnt) n+=Lines+1;
    }
    else        //  
    {   for (Lin=First,n=1; Lin!=Last; Lin=GetNext(Lin),n++)
                if (n==num) break;
    }
    Lineno=n;
    Scr=Cur=Lin;
    Mfin=xpos=0;
    ypos=0;
    DrawView();
    Refresh();
    frame();
} //Edit::GotoLine

char *basekeys[]=
{"Help","Save","Open","Mark","Paste","Next","Search","","Spaces","Quit"};
char *blkeys[]=
{"Help","Save","Open","UnMark","Copy","Next","Search","Delete","Spaces","Quit"};
char *viewkeys[]=
{"Help","","Open","Edit","","Next","Search","","Spaces","Quit"};

char **curkeybar=basekeys;

char **showkeybar (char **keys)
{       Key->A.Y=SHIGHT;
        Key->B.Y=Key->A.Y+1;
        return Key->SetKeys(keys);
} //showkeybar

//  
void Edit::frame()
{ App->Handle(t=cmFrame);
  App->Handle(t=cmKeys);
} //Edit::frame

//    
void Edit::reframe()
{ App->Handle(t=cmFrameDraw);
  App->Handle(t=cmKeysDraw);
} //Edit::reframe

//     
void Edit::insnewline (char *buf)
{       if (buf==NULL) buf="";
        VStr *p= NewVStr(buf);
        p->Prev=Cur;
        p->Next=Cur->Next;
        if (p->Prev!=NULL)
                p->Prev->Next=p;
        if (p->Next!=NULL)
                p->Next->Prev=p;
        if (Cur==Last) Last=p;
        Cur=p;
        changed=1;
        UndoBuf->put(undo_el(INS,NULL,GetNext(Cur),oldx,Lineno,Lines));
} //Edit::insnewline

//   
void Edit::ScrollUp()
{       Scr=GetPrev(Scr);
        scrup(0);
        sout(0,A.Y,GetVStr(Scr),0,belong(Cur,MarkBlk,Scr,vert));
        frame();
} //Edit::ScrollUp

//   
void Edit::ScrollDown ()
{       Scr=GetNext(Scr);
        VStr *p=getlowline();
        scrdn(0);
        if (p)
             sout(0,B.Y,GetVStr(p),(p==Last)&&(p!=Scr),
                belong(Cur,MarkBlk,p,vert));
        else sout(0,B.Y,"",0,0);
        frame();
} //Edit::ScrollDown

//    
void Edit::DelLine (int off)
{ VStr *p,*pp;
  int i,j;
        for (i=0,pp=Cur; (i<off) &&(pp!=Last); i++)
                pp=GetNext(pp);
        delline(pp);
        for (i=0, j= -1, p=Scr; (i<=(B.Y-A.Y)) && (GetNext(p)); i++)
        {       if (p==Cur) j=i;
                if (i<(B.Y-A.Y)) p=GetNext(p);
        }
        if (j==-1) return;
        scrdn(j+off);
        sout(0,B.Y,GetVStr(p),p==Last,belong(Cur,MarkBlk,p,vert));
} //Edit::DelLine

//    
void Edit::InsLine (char *buf, int flag)
{ VStr *p;
  int i,j;
        for (i=0, j= -1, p=Scr; (i<=(B.Y-A.Y)) && (GetNext(p)); i++)
        {       if (p==Cur) j=i;
                p=GetNext(p);
        }
        insnewline(buf);
        if (j==-1) return;
        if (flag)
        {       scrup(j+1);
                sout(0,A.Y+j+1,GetVStr(Cur),Cur==Last,belong(Cur,MarkBlk,p,vert));
        }
        else
        {       scrdn(0);
                sout(0,A.Y+j+1,GetVStr(Cur),Cur==Last,belong(Cur,MarkBlk,p,vert));
        }
} //Edit::InsLine

//    
void Edit::delline(VStr *p)
{ repline(p,NULL); }

void Edit::delbuf (VStr *AA,VStr *BB)
{ int i=0;
  int flag;
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        if (comp(AA,BB)>0) { VStr *t=AA; AA=BB; BB=t;}
        flag=(Cur==BB);
        while (AA!=BB)
        {       VStr* p=GetNext(AA);
                delline(AA);
                AA=p;
                i++;
        }
        ypos=calcy(Cur);
        xpos=0;
        Lines-=i;
        if (flag) Lineno-=i;
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::delbuf

VStr *Edit::clearbuf (int add)
{ VStr *cur, *q;
        if (Buf==NULL) return NULL;
        if (add)
                for (cur=Buf; cur->Next; cur=cur->Next);
        else
        {       for (q=Buf; q;)         //   
                {       VStr *p=q->Next;
                        DisposeVStr(q);
                        q=p;
                }
                Buf=cur=0;
        }
        return cur;
} //Edit::clearbuf

void Edit::cutbuf (VStr *AA, VStr *BB, int add)
{ int i=0;
  int flag;
  VStr *q,*cur;
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        cur=clearbuf(add);
        if (comp(AA,BB)>0) { VStr *t=AA; AA=BB; BB=t;}
        flag=(Cur==BB);
        while (AA!=BB)
        {       VStr* p=GetNext(AA);
                q=NewVStr(GetVStr(AA));
                if (Buf==NULL)
                        Buf=cur=q;
                else
                {       cur->Next=q;
                        q->Prev=cur;
                        cur=q;
                }
                delline(AA);
                AA=p;
                i++;
        }
        ypos=calcy(Cur);
        xpos=0;
        Lines-=i;
        if (flag) Lineno-=i;
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::cutbuf

void Edit::copybuf (VStr *AA, VStr *BB, int add)
{ VStr *q,*cur;
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        cur=clearbuf(add);
        if (comp(AA,BB)>0) { VStr *t=AA; AA=BB; BB=t;}
        while (AA!=BB)
        {       q=NewVStr(GetVStr(AA));
                if (Buf==NULL)
                        Buf=cur=q;
                else
                {       cur->Next=q;
                        q->Prev=cur;
                        cur=q;
                }
                AA=GetNext(AA);
        }
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::copybuf

void Edit::copyline (VStr *AA, int add)
{ VStr *q,*cur;
        cur=clearbuf(add);
        q=NewVStr(GetVStr(AA));
        if (Buf==NULL)
                Buf=cur=q;
        else
        {       cur->Next=q;
                q->Prev=cur;
                cur=q;
        }
} //Edit::copyline

void Edit::pastebuf()
{ VStr *q,*f=NULL;
  int i;
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        for (q=Buf,i=0; q; q=GetNext(q),i++)
        {       VStr *p= NewVStr(GetVStr(q));
                if (i==0) f=p;
                p->Prev=Cur->Prev;
                p->Next=Cur;
                p->Next->Prev=p;
                if (p->Prev!=NULL)
                        p->Prev->Next=p;
                if (First==Cur) First=p;
                changed=1;
                UndoBuf->put(undo_el(INS,NULL,GetNext(p),oldx,Lineno,Lines));
        }
        Cur=f;
        ypos=calcy(Cur);
        if (ypos<0)
        {       ypos=0;
                Scr=Cur;
        }
        xpos=0;
        Lines+=i;
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::pastebuf

void Edit::delvbuf (VStr *AA,VStr *BB)
{ char buf[MAXSTR+1];
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        if (comp(AA,BB)>0) { VStr *t=AA; AA=BB; BB=t;}
        VStr *end=GetNext(BB);
        while (AA!=end)
        {       VStr *p=GetNext(AA);
                strcpy(buf,GetVStr(AA));
                xpos=delcol(Mbeg,Mfin,buf);
                RepTxt(AA,buf);
                AA=p;
        }
        getline(strbuf);
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::delvbuf

void Edit::copyvbuf (VStr *AA, VStr *BB, int add)
{ VStr *q,*cur;
  char buf[MAXSTR+1];
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        cur=clearbuf(add);
        if (comp(AA,BB)>0) { VStr *t=AA; AA=BB; BB=t;}
        VStr *end=GetNext(BB);
        while (AA!=end)
        {       copycol(Mbeg,Mfin,GetVStr(AA),buf);
                q=NewVStr(buf);
                if (Buf==NULL)
                        Buf=cur=q;
                else
                {       cur->Next=q;
                        q->Prev=cur;
                        cur=q;
                }
                AA=GetNext(AA);
        }
        getline(strbuf);
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::copyvbuf

void Edit::cutvbuf (VStr *AA, VStr *BB, int add)
{ VStr *q,*cur;
  char buf[MAXSTR+1];
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        cur=clearbuf(add);
        if (comp(AA,BB)>0) { VStr *t=AA; AA=BB; BB=t;}
        VStr *end=GetNext(BB);
        while (AA!=end)
        {       VStr *p=GetNext(AA);
                copycol(Mbeg,Mfin,GetVStr(AA),buf);
                q=NewVStr(buf);
                if (Buf==NULL)  Buf=cur=q;
                else
                {       cur->Next=q;
                        q->Prev=cur;
                        cur=q;
                }

                strcpy(buf,GetVStr(AA));
                xpos=delcol(Mbeg,Mfin,buf);
                RepTxt(AA,buf);
                AA=p;
        }
        getline(strbuf);
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::cutvbuf

void Edit::pastevbuf()
{ char buf[MAXSTR+1];
  VStr *AA,*lin;
        if (Buf==NULL) return;
        UndoBuf->put(undo_el(ENDGROUP,oldx,Lineno,Lines));
        for (AA=Cur,lin=Buf; lin; lin=GetNext(lin))
        {       VStr *p=GetNext(AA);
                strcpy(buf,GetVStr(AA));
                xpos=pastecol(xpos,buf,GetVStr(lin));
                RepTxt(AA,buf);
                AA=p;
                if (AA==Last->Next)      //     
                {       p=NewVStr();
                        p->Prev=Last;
                        p->Next=Last->Next;
                        if (p->Prev!=NULL)
                                p->Prev->Next=p;
                        if (p->Next!=NULL)
                                p->Next->Prev=p;
                        AA=Last=p;
                        UndoBuf->put(undo_el(INS,NULL,GetNext(p),oldx,Lineno,Lines));
                }
        } //for
        getline(strbuf);
        UndoBuf->put(undo_el(GROUP,oldx,Lineno,Lines));
} //Edit::pastevbuf

//    
void Edit::getline (char *buf)
{       strcpy(buf,GetVStr(Cur));
        iseof=(Cur==Last);
} //Edit::getline

//     
void Edit::putline (char *buf)
{       if (!modified) return;
        RepTxt(Cur,buf);
        modified=0;
} //Edit::putline

//     L  txt
void Edit::RepTxt (VStr *L, char *txt)
{       repline(L, NewVStr(txt));
} //Edit::RepTxt

//     old   newp
//  ( newp==NULL,  )
void Edit::repline (VStr *old, VStr *newp, int undo)
{       if (Last->Next==old) return;
        changed=1;
        if (newp)       //   newp
        {       if (First==old) First=newp;
                if (Last==old)  Last=newp;
                if (Cur==old)   Cur=newp;
                if (Scr==old)   Scr=newp;
                if (old->Prev)  old->Prev->Next=newp;
                if (old->Next)  old->Next->Prev=newp;
                newp->Prev=old->Prev;
                newp->Next=old->Next;
        }
        else            // 
        {
                if (Last==old)
                {       if (old->Prev==NULL)
                        {       GetVStr(Last)[0]=0;
                                return;
                        }
                        if (Scr==old) Scr=GetPrev(Scr);
                        if (Cur==old)
                        {       Cur=GetPrev(Cur);
                                if (ypos>0) ypos--;
                                else ScrollUp();
                                getline(strbuf);
                                xpos=len(strbuf);
                        }
                        Last=Last->Prev;
                }
                else
                {       if (First==old) First=First->Next;
                        if (Cur==old)   Cur=Cur->Next;
                        if (Scr==old)   Scr=Scr->Next;
                }
                if (old->Prev)  old->Prev->Next=old->Next;
                if (old->Next)  old->Next->Prev=old->Prev;
        }
        for (int i=0; i<10; i++)
                if (MarkPosY[i]==old) MarkPosY[i]=newp;
        if (MarkBlk==old) MarkBlk=newp;
        if (undo)
                DisposeVStr(old);     //   Redo
        else
        {       UndoBuf->put(undo_el(newp?REPL:DEL,old,newp?newp:old->Next,
                                oldx,Lineno,Lines));
                old->Next=old->Prev=NULL;
        }
        modified=0;
} //Edit::repline

void Edit::unmark()
{       showkeybar(basekeys);
        int y0=calcy(MarkBlk);
        int y1=calcy(Cur);
        MarkBlk=NULL;
        Mbeg=Mfin=0;
        vert=0;
        trig=1;
        if ((y0<0)||(y1<0)) DrawView();
        else
        {       if (y1<y0) {int t=y0; y0=y1; y1=t;}
                Rect R=getCoord();
                Dirty.Assign(R.A.X,R.A.Y+y0,R.B.X,R.A.Y+y1);
                Refresh();
        }
} //unmark

void Edit::showchanges()
{   if (MarkBlk&&vert&&(xpos!=oldx))
    {   Rect R=getCoord();
        int beg=calcy(Cur);
        int fin=calcy(MarkBlk);
        if (beg>fin) {int t=fin; fin=beg; beg=t;}
        Dirty.Assign(R.A.X,R.A.Y+beg,R.B.X,R.A.Y+fin);
        Refresh();
    }
    else
        sout(0,ypos+A.Y,GetVStr(Cur),Cur==Last,belong(Cur,MarkBlk,Cur,vert));
} //Edit::showchanges

int Edit::chkdown()
{       VStr *p;
        int i;
        for (p=Scr,i=0; GetNext(p)&&(i<=B.Y-A.Y+1); i++,p=GetNext(p));
        if (i<=B.Y-A.Y+1) return 1;
        return 0;
} //Edit::chkdown

void loop (View *p, int i)
{       p->Handle(t=cmReSize);
}

void zloop (View *p, int i)
{       p->Handle(t=cmZoom);
}

int is_blank (char *str)
{       if (str==NULL) return 1;
        while ((*str==' ')||(*str==TAB)) str++;
        if (*str==0) return 1;
        return 0;
}

int putflag=0;

char Names[256];

//    
//  (.  Edit::getsym())
unsigned Edit::Handle (unsigned &c)
{ int i,num= -1;
  unsigned res;
  VStr *P;
        putline(strbuf);
        switch (c)
        { case cmFrame:
          case cmFrameDraw:
          case 0:
                return 0;
          case cmGetName:
          	if (Names[0]) strncat(Names,", ",256-strlen(Names));
          	strncat(Names,Name,256-strlen(Names));
          	return 0;
          case cmSaveStat:
                if (StatFile==0) break;
                fprintf(StatFile,"File = %s\n",Name);
                fprintf(StatFile,"Line = %d\n",Lineno);
                fprintf(StatFile,"Ypos = %d\n",ypos);
                fprintf(StatFile,"Xpos = %d\n",xpos);
                fprintf(StatFile,"Xoffset = %d\n",xoffset);
                VStr *p;
                int marky[10];
                for (i=0; i<10; i++) marky[i]=0;
                for (p=First,i=1; p; p=GetNext(p), i++)
                {   int flag=0;
                    for (int j=0; j<10; j++)
                    {   if (p==MarkPosY[j])
                        {   marky[j]=i;         //   
                            MarkPosY[j]=NULL;   // ,  
                        }
                        if (MarkPosY[j]) flag++;
                    }
                    if (flag==0) break; //    
                }
                for (i=0; i<10; i++)
                    if (marky[i]>0)
                    {   fprintf(StatFile,"Mark%d = %d %d\n",i,MarkPosX[i],marky[i]);
                    }
                return 0;
          case cmZoom:
                if (zoom)
                {       Rect R=((EWindow*)Owner)->Zoom;
                        Owner->Assign(R.A.X,R.A.Y,R.B.X,R.B.Y);
                        Owner->Show();
                }
                else
                {       Owner->Hide();
                        Owner->Assign(0,0,SWIDTH,SHIGHT-1);
                }
                return 0;
          case cmSaveAll:
          case cmSave:
                if (putfile()) return 0;
                Refresh();
                break;
          case cmCloseAll:
                if (!changed) return 0;
                res=ExitDlg(Name);
                if (res!=cmCancel)
                {       if (res==cmNo) return 0;
                        if (closefile()) return 0;
                }
                Refresh();
                c=0;
                return cmCancel;
          case cmSwitchEdit:
                ((EWindow*)Owner)->F->RemoveAll();
                ((EWindow*)Owner)->EFrame(GapCnt);
                if (xoffset>0) xpos=xoffset+1;
                return 0;
          case _Zoom:
                if (wcnt<=1)    //    
                        zoom=0;
                else
                {       indexx=0;
                        App->ForEach(&zloop);   //App->Handle(t=cmZoom);
                        App->DrawView();
                        zoom=!zoom;
                }
                break;
          case _F10:
          case _Esc:
          case 'Q':
          case 'q':
                SaveStat();
                res=App->Handle(t=cmCloseAll);
                if (res==0) return cmOK;
                c=0;
                Refresh();
                break;
          case _ShiftF10:
                if (App->Handle(t=cmSaveAll)==0)
                        return cmOK;
                c=0;
                Refresh();
                break;
          case _F1:
                Help();
                Refresh();
                break;
          case _AltF1:
          case _ShiftF1:
          case _Config:
                Config();
                Refresh();
                break;
          case _F2:
                if (view) break;
                if (!changed) break;
                putfile();
                Refresh();
                break;
          case _AltF2:
                if (view) break;
                App->Handle(t=cmSaveAll);
                Refresh();
                break;
          case _ShiftF2:
                if (view) break;
                { char name[80];
                  strncpy(name,Name,sizeof(name));
                  if (cmCancel!=GetName(name))
                        putfile(name);
                }
                Refresh();
                break;
          case _AltF9:
                if (view) break;
                { char command[100]="";
                  if (cmCancel!=GetCommand(command))
                  {     loadexec(command);
                        DrawView();
                  }
                }
                Refresh();
                putflag=0;
                break;
          case _Shell:
                ::Color(0); clrscr();
                fflush(stdout);
                closetty();
                fprintf(stderr,"Press 'exit' to return...\n");
#ifdef __MSDOS__
                system(getenv("COMSPEC"));
#else
                system(getenv("SHELL"));
#endif
                initty();
                App->DrawView();
                break;
          case _Load:
                if (view) break;
                { char name[80]="";
                  if (cmCancel!=GetNewName(name))
                  {     loadfile(name);
                        DrawView();
                  }
                }
                Refresh();
                putflag=0;
                break;
          case _Store:
                if (view) break;
                if (MarkBlk)
                { char name[80]="";
                  if (cmCancel!=GetFName(name))
                  {     storefile(name,MarkBlk,Cur);
                        MarkBlk=NULL;
                        vert=0;
                        showkeybar(basekeys);
                        DrawView();
                  }
                }
                Refresh();
                break;
          case _F3:
                if (SHIGHT/(wcnt+1)<2) break;
                { char name[256]="";
                  if (cmCancel!=GetNewName(name))
                  { EWindow *p=new EWindow(
                        Rect(0,wcnt*SHIGHT/(wcnt+1),SWIDTH,SHIGHT-1),name,0);
                    if (p->status>=0)
                         App->Insert(p);
                    else delete p;
                  }
                }
                indexx=0;
                App->ForEach(&loop);     //App->Handle(t=cmReSize);
                App->DrawView();
                break;
          case _Close:
          case _AltF3:
                c=0;
                if (changed)
                {       res=ExitDlg(Name);
                        if (res==cmCancel)
                        {       Refresh();
                                return 0;
                        }
                        else if (res==cmYes) closefile();
                }
                indexx=0;
                Owner->Owner->Remove(Owner);
                if (wcnt<=1) return cmOK;
                delete Owner;
                App->ForEach(&loop);     //App->Handle(t=cmReSize);
                App->DrawView();
                putflag=0;
                return 0;
          case _F4:
          case _ShiftF4:
                if (view)
                {       res=EdDlg();
                        Refresh();
                        if (res!=cmYes) break;
                        view=0;
                        makeswap();
                        Key->SetKeys(basekeys);
                        App->Handle(t=cmSwitchEdit);
                        break;
                }
                if (MarkBlk) unmark();
                else
                {       MarkBlk=Cur;
                        vert=0; trig=0;
                        Mbeg=Mfin=xpos;
                        showkeybar(blkeys);
                        c=0;
                        return 0;
                }
                break;
          case _F5:
                if (view) break;
                if (MarkBlk==NULL)
                {       if (Buf==NULL) break;
                        if (::Vert)
                                pastevbuf();
                        else    pastebuf();
                        showkeybar(basekeys);
                        DrawView();
                        putflag=0;
                }
                else
                {       if (vert)
                                copyvbuf(MarkBlk,Cur,0);
                        else    copybuf(MarkBlk,Cur,0);
                        Vert=vert;
                        unmark();
                        putflag=1;
                }
                break;
          case _AddBuf:
                if (view) break;
                if (MarkBlk==NULL) break;
                if (vert)
                        copyvbuf(MarkBlk,Cur,1);
                else    copybuf(MarkBlk,Cur,1);
                Vert=vert;
                unmark();
                putflag=1;
                break;
          case _CutAddBuf:
                if (view) break;
                if (MarkBlk==NULL) break;
                if (vert)
                        cutvbuf(MarkBlk,Cur,1);
                else    cutbuf(MarkBlk,Cur,1);
                Vert=vert;
                unmark();
                putflag=1;
                break;
          case _F6:
                App->SelectNext();
                break;
          case _ShiftF6:
          case _AltF6:
                App->SelectNext(0);
                break;
          case _ShiftF5:
          case _AltF5:
          case _ShiftF8:
          case _AltF8:
                if (view) break;
                if (MarkBlk==NULL) break;
                if (vert)
                        cutvbuf(MarkBlk,Cur,0);
                else    cutbuf(MarkBlk,Cur,0);
                MarkBlk=NULL;
                Vert=vert;
                vert=0;
                showkeybar(basekeys);
                DrawView();
                putflag=1;
                break;
          case _F8:
                if (MarkBlk==NULL) break;
                if (vert)
                        delvbuf(MarkBlk,Cur);
                else    delbuf(MarkBlk,Cur);
                MarkBlk=NULL;
                vert=0;
                showkeybar(basekeys);
                DrawView();
                putflag=0;
                break;
          case _F9:
                getline(strbuf);
                spaces=!spaces;
                App->DrawView();
                break;
          case _F7:
          case '/':
                if (cmOK==SearchDlg())
                    if (Search(Pattern,Case,Words,FromTop,Reg,Back,1)<0)
                        NotFoundMsg();
                Mfin=xpos;
                if (MarkBlk)
                     App->DrawView();
                else Refresh();
                break;
          case _SearchRepl:
          case _AltF7:
                if (cmOK==SRepDlg())
                {  Mfin=xpos;
                   if (MarkBlk) DrawView();
                   else Refresh();
                   if (SearchRepl(Pattern,Repl,Case,Words,
                                FromTop,All,Prompt,Reg,1)<0)
                        NotFoundMsg();
                }
                Mfin=xpos;
                if (MarkBlk)
                     DrawView();
                else Refresh();
                break;
          case _ShiftF7:
          case _SearchNext:
                if (Pattern[0]==0) break;
                if (replace)
                {   if (SearchRepl(Pattern,Repl,Case,Words,
                                FromTop,All,Prompt,Reg,0)<0)
                        NotFoundMsg();
                }
                else if (Search(Pattern,Case,Words,FromTop,Reg,Back,0)<0)
                        NotFoundMsg();
                Mfin=xpos;
                if (MarkBlk) DrawView();
                break;
          case _GotoLine:
                if ((cmCancel!=NumDlg(num))&&(num!=0))
                        GotoLine(num);
                else if (MarkBlk) App->DrawView();
                else Refresh();
                break;
          case _Repeat:
                if ((cmCancel!=RepDlg(num))&&(num>0))
                {       if (MarkBlk) App->DrawView();
                        else Refresh();
                        if (num<=0) break;
                        repeat=num;
                        play=1;
                }
                else if (MarkBlk) App->DrawView();
                else Refresh();
                break;
          case _set0: case _set1:       //  
          case _set2: case _set3:
          case _set4: case _set5:
          case _set6: case _set7:
          case _set8: case _set9:
                MarkPosY[c-_set0]=Cur;
                MarkPosX[c-_set0]=xpos;
                break;
          case _goto0: case _goto1:     //   
          case _goto2: case _goto3:
          case _goto4: case _goto5:
          case _goto6: case _goto7:
          case _goto8: case _goto9:
                P=MarkPosY[c-_goto0];
                if (P==NULL) {play=0;prtc(_bell);break;}
                Cur=Scr=P;
                for (P=First,Lineno=1; P!=Cur; P=GetNext(P),Lineno++);
                ypos=0; Mfin=xpos=MarkPosX[c-_goto0];
                DrawView();
                break;
          case _Refresh:
                scrsize();
                indexx=0;
                App->ForEach(&loop);     //App->Handle(t=cmReSize);
                App->DrawView();
                showkeybar(basekeys);
                break;
          case _Reframe:
                frame();
          case cmReDraw:
                ReDraw();
                return 0;
          case _Left:
                if (!view) break;
                if (xoffset>0)
                {       xoffset-=8;
                        DrawView();
                }
                break;
          case _Right:
                if (!view) break;
                if (xoffset<MAXSTR-SWIDTH) xoffset+=8;
                DrawView();
                break;
          case _Up:
                if (GetPrev(Cur)==NULL) {play=0;break;}
                if (view)
                {       if (yy>=0) yy++;
                        ScrollUp();
                }
                else if (ypos>0)
                        ypos--;
                else    ScrollUp();
                Cur=GetPrev(Cur);
                if (MarkBlk)
                {       if (GetNext(Cur))
                            sout(0,ypos+A.Y+1,GetVStr(GetNext(Cur)),Cur->Next==Last,
                                belong(Cur,MarkBlk,Cur->Next,vert));
                        sout(0,ypos+A.Y,GetVStr(Cur),Cur==Last,
                                belong(Cur,MarkBlk,Cur,vert));
                }
                Lineno--;
                break;
          case _Down:
                if (Cur==Last) {play=0;break;}
                if (view)
                {       if (chkdown()) break;
                        if (yy>=0) yy--;
                        ScrollDown();
                }
                else if (ypos<(B.Y-A.Y))
                        ypos++;
                else    ScrollDown();
                Cur=GetNext(Cur);
                if (MarkBlk)
                {       if (GetPrev(Cur))
                            sout(0,ypos+A.Y-1,GetVStr(GetPrev(Cur)),Cur->Prev==Last,
                                belong(Cur,MarkBlk,Cur->Prev,vert));
                        sout(0,ypos+A.Y,GetVStr(Cur),Cur==Last,
                                belong(Cur,MarkBlk,Cur,vert));
                }
                Lineno++;
                break;
          case _PgUp:
                if (Cur==First) {play=0;break;}
                for (i=0; (i<=(B.Y-A.Y)) && GetPrev(Cur); i++)
                {       if (GetPrev(Scr))
                        {       Scr=GetPrev(Scr);
                                ypos++;
                        }
                        Cur=GetPrev(Cur);
                        Lineno--;
                        ypos--;
                }
                if (view || (ypos<0)) ypos=0,yy= -1;
                DrawView();
                break;
          case _PgDn:
          case ' ':
                if (Cur==Last) {play=0;break;}
                if (view&&chkdown()) break;
                if (!view && (getlowline()==Last))
                {   for (; (GetNext(Cur)) && (Cur!=Last); Cur=GetNext(Cur))
                    {   Lineno++;
                        ypos++;
                    }
                }
                else
                {   for (i=0; (i<=(B.Y-A.Y)) && (GetNext(Cur)) && (Cur!=Last); i++)
                    {   if (GetNext(Scr))
                            {   Scr=GetNext(Scr);
                                ypos--;
                            }
                            Cur=GetNext(Cur);
                            Lineno++;
                            ypos++;
                    }
                    if (ypos>(B.Y-A.Y)) ypos=(B.Y-A.Y);
                    if (view) ypos=0, yy= -1;
                    DrawView();
                }
                break;
          case _Home:
                if (!view) break;
          case _Top:
                ypos=0; Mfin=xpos=0; yy= -1;
                xoffset=0;
                Lineno=1;
                if ((Scr==First)&&(MarkBlk==NULL)&&(xoffset==oldxoffs))
                        Cur=Scr=First;
                else
                {       Cur=Scr=First;
                        DrawView();
                }
                break;
          case _End:
                if (!view) break;
          case _Bottom:
                Cur=Scr=Last;
                getline(strbuf);
                ypos=0; Mfin=xpos=len(strbuf); yy= -1;
                corrxoffs();
                if (GapCnt)
                        Lineno= -1;
                else    Lineno=Lines;
                while ((GetPrev(Scr)!=NULL)&&(ypos<(B.Y-A.Y)))
                {       Scr=GetPrev(Scr);
                        if (view) Lineno--;
                        ypos++;
                }
                if (view)
                {       ypos=0;
                        Cur=Scr;
                }
                DrawView();
                break;
          case _ShiftEnter:
                if (view) break;
                sout(0,ypos+A.Y,GetVStr(Cur),0,belong(GetNext(Cur),MarkBlk,Cur,vert));
                if (ypos<(B.Y-A.Y))
                {       ypos++;
                        InsLine(NULL);
                }
                else
                {       Scr=GetNext(Scr);
                        InsLine(NULL,0);
                }
                Mfin=xpos=xoffset=0;
                Lines++;
                if (Lineno>=0) Lineno++;
                showchanges();
                putflag=0;
                break;
          case _Enter:
                if (view)
                { c=_Down;
                  return Handle(c);
                }
                UndoBuf->put(undo_el(ENDGROUP2,oldx,Lineno,Lines));
                delright(xpos,strbuf);
                putline(strbuf);
                char lbuf[MAXSTR+1];
                lbuf[0]=0;
                if (AutoIndent) getindent(strbuf,lbuf);
                else if (Fmt)
                    for (i=0; i<LeftMargin; i++) strcat(lbuf," ");
                Mfin=xpos=len(lbuf);
                xoffset=0;
                strncat(lbuf,tstr,MAXSTR);
                sout(0,ypos+A.Y,GetVStr(Cur),0,belong(GetNext(Cur),MarkBlk,Cur,vert));
                if (ypos<(B.Y-A.Y))
                {       ypos++;
                        InsLine(lbuf);
                }
                else
                {       Scr=GetNext(Scr);
                        InsLine(lbuf,0);
                }
                Lines++;
                if (Lineno>=0) Lineno++;
                showchanges();
                UndoBuf->put(undo_el(GROUP2,oldx,Lineno,Lines));
                putflag=0;
                break;
          case _delLine:
          case _PutLine:
                if (view) break;
                if (c!=_PutLine)
                        putflag=0;
                else
                {       copyline(Cur,putflag);
                        putflag=1;
                }
                Mfin=xpos=xoffset=0;
                if (Cur==Last)
                {       if (*GetVStr(Last))
                                repline(Last,NewVStr(""));
                }
                else
                {       DelLine();
                        Lines--;
                        if (Lineno<0) Lineno++;
                }
                showchanges();
                break;
          case _Del:
                if (view) break;
                if (Cur!=Last)
                {   UndoBuf->put(undo_el(ENDGROUP2,oldx,Lineno,Lines));
                    addstr(GetVStr(GetNext(Cur)),xpos,strbuf);
                    putline(strbuf);
                    DelLine(1);
                    showchanges();
                    Lines--;
                    if (Lineno<0) Lineno++;
                    UndoBuf->put(undo_el(GROUP2,oldx,Lineno,Lines));
                    //Format();
                }
                putflag=0;
                break;
          case _delBlanks:
                if (view) break;
                if (Cur!=Last)
                {   UndoBuf->put(undo_el(ENDGROUP2,oldx,Lineno,Lines));
                    for (;;)
                    {   if (GetNext(Cur)==Last) break;
                        if (is_blank(GetVStr(GetNext(Cur))))
                        {       DelLine(1);
                                showchanges();
                                Lines--;
                                if (Lineno<0) Lineno++;
                                continue;
                        }
                        addstr(GetVStr(GetNext(Cur)),xpos,strbuf);
                        putline(strbuf);
                        DelLine(1);
                        showchanges();
                        Lines--;
                        if (Lineno<0) Lineno++;
                        UndoBuf->put(undo_el(GROUP2,oldx,Lineno,Lines));
                        break;
                    }
                }
                putflag=0;
                break;
          case _BS:
                if (view) break;
                if (GetPrev(Cur)!=NULL)
                {   UndoBuf->put(undo_el(ENDGROUP2,oldx,Lineno,Lines));
                    Cur=GetPrev(Cur);
                    getline(strbuf);
                    Mfin=xpos=len(GetVStr(Cur));
                    corrxoffs();
                    addstr(GetVStr(GetNext(Cur)),xpos,strbuf);
                    putline(strbuf);
                    if (ypos>0) ypos--;
                    else ScrollUp();
                    if (xpos==0)
                        DelLine();
                    else
                    {   DelLine(1);
                        showchanges();
                    }
                    Lines--;
                    if (Lineno>=0) Lineno--;
                    UndoBuf->put(undo_el(GROUP2,oldx,Lineno,Lines));
                    //Format();
                }
                putflag=0;
                break;
          case _Undo:
                if (view) break;
                if (!restore()) {play=0;prtc(_bell);}
                putflag=0;
                break;
          case _Brackets:
                { int ch=getschar(xpos,GetVStr(Cur));
                  int r=0;
                  switch (ch)
                  { case '(':   r=BrackF("(",")"); break;
                    case '[':   r=BrackF("[","]"); break;
                    case '{':   r=BrackF("{","}"); break;
                    case '"':   r=BrackF("\"","\""); break;
                    case '\'':  r=BrackF("\'","\'"); break;
                    case ')':   r=BrackB("(",")"); break;
                    case ']':   r=BrackB("[","]"); break;
                    case '}':   r=BrackB("{","}"); break;
                    default:
                        char *line=GetVStr(Cur);
                        if (matchword(xpos,line,"begin"))
                                r=BrackF("begin","end");
                        else if (matchword(xpos,line,"end"))
                                r=BrackB("begin","end");
                        else if (matchword(xpos,line,"/*"))
                                r=BrackF("/*","*/");
                        else if (matchword(xpos,line,"*/"))
                                r=BrackB("/*","*/");
                  }
                  if (r==0) {play=0; prtc(_bell);}
                }
                break;
          default:
                if (c<cm_) {play=0; prtc(_bell);}
                else return 0;
        }
        getline(strbuf);
        c=0;
        trig=1;
        oldx=xpos;
        oldy=ypos;
        return 0;
} //Edit::Handle
