#include <stdio.h>
#include <string.h>
#include <setjmp.h>
#include "kbd.h"

#ifdef __MSDOS__
#include <conio.h>
#include <ctype.h>
#include "dialogs.h"
#else

#include <stdlib.h>
#ifndef NOTERMIOS
#include <termios.h>
#else
#include <sys/termio.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>

#endif

static int symsmark;

int StrCmp (const char *s1, const char*s2);
int StrNCmp (const char *s1, const char *s2, size_t maxlen);
int StrLen (const char *s);

int ctrl=0;

int _tty;
//  
#ifdef __MSDOS__
int speed=9600;
int minspeed=0;
#else
#ifndef NOTERMIOS
struct termios tt,tt0;
speed_t speed,minspeed=0;
#else
struct termio tt,tt0;
int speed,minspeed=0;
#endif
#endif

int initty()
{ int i;
#ifndef __MSDOS__
        if ((_tty=open("/dev/tty",O_RDWR)) < 0)
        {    fprintf(stderr, "Could not open /dev/tty\n");
            _exit(0);
        }
#ifdef NOTERMIOS
        ioctl(_tty,TCGETA,&tt0);
        ioctl(_tty,TCGETA,&tt);
#else
        tcgetattr(_tty, &tt0);
        tcgetattr(_tty, &tt);
#endif
        tt.c_iflag&=~(ICRNL|BRKINT|INLCR);
        tt.c_lflag=NOFLSH;
        tt.c_cc[VMIN]=1;
        tt.c_cc[VTIME]=0;

#ifdef NOTERMIOS
        ioctl(_tty,TCSETAF,&tt);
#else
        tcsetattr(_tty, TCSANOW, &tt);
#endif
#endif
        for (i=0; i<256; i++) //    
            if (syms[i].code==10000) symsmark=i;
            else if (syms[i].code==0) break;
        return _tty;
} // initty

static char symbuf[128];
static int bufbeg, bufend;

void setwait (int m)
{
#ifndef __MSDOS__
#ifdef NOTERMIOS
        ioctl(_tty,TCGETA,&tt);
#else
        tcgetattr(_tty, &tt);
#endif
        tt.c_cc[VMIN]=m;
        tt.c_cc[VTIME]=0;
#ifdef NOTERMIOS
        ioctl(_tty,TCSETA,&tt);
#else
        tcsetattr(_tty, TCSANOW, &tt);
#endif
#endif
        if (m==0) bufend=bufbeg=0;
} //setwait

void setw (int m)
{
#ifndef __MSDOS__
#ifdef NOTERMIOS
        ioctl(_tty,TCGETA,&tt);
#else
        tcgetattr(_tty, &tt);
#endif
        if (m)
        {       tt.c_cc[VMIN]=0;
                tt.c_cc[VTIME]=3;
        }
        else
        {       tt.c_cc[VMIN]=1;
                tt.c_cc[VTIME]=0;
        }
#ifdef NOTERMIOS
        ioctl(_tty,TCSETA,&tt);
#else
        tcsetattr(_tty, TCSANOW, &tt);
#endif
#endif
} //setw

void closetty()
{
#ifndef __MSDOS__
#ifdef NOTERMIOS
        ioctl(_tty,TCSETAF,&tt0);
#else
        tcsetattr(_tty, TCSAFLUSH, &tt0);
#endif
        close(_tty);
#endif
} //closetty

void kbdmin()   //   
{ /*if (symsmark) syms[symsmark].code=0;*/ }

void kbdmax()   //   
{ /*if (symsmark) syms[symsmark].code=10000;*/ }

//     _tty
#define MAXSYM 16
extern char RusMap[];
extern char *_rusmap;
int RUS;

static char gs()
{ char c=0;
        if (bufbeg<bufend)
                return symbuf[bufbeg++];
#ifdef __MSDOS__
static int Esc=0;
        c=getch();
        if (c==0)
        { c=033; Esc=1;}
        else if (Esc)
        {       switch (c)
                { case 'P': c='d'; break;
                  case 'H': c='u'; break;
                  case 'M': c='r'; break;
                  case 'K': c='l'; break;
                  case 'Q': c='n'; break;
                  case 'I': c='p'; break;
                  case 'G': c='h'; break;
                  case 'O': c='e'; break;
                  case 'S': c='t'; break;
                  case 'R': c='i'; break;
                }
                Esc=0;
        }
        else    Esc=0;
#else
#ifdef Win32
        c=getkey();
#else
        if (read(_tty,&c,1)==0)
                setw(0);
        else    setw(1);
#endif
#endif
        return c;
}

int CtrlBreak()
{ char c=0;
#ifdef __MSDOS__
        if (kbhit())
        {       c=getch();
                if (c==0) c=033;
        }
#else
#ifdef Win32
        return 0;
#else
        if (read(_tty,&c,1)==0) c=0;
#endif
#endif
        if (c&&(c!=_CtrlC)&&(bufend<(int)sizeof(symbuf))) symbuf[bufend++]=c;
        return (c==_CtrlC);
} //CtrlBreak

//   
int Comp (char *a, char *b)
{ int i;
        if (a==NULL) return 0;
        if (b==NULL) return 0;
        for (i=0; a[i]&&b[i]; i++)
                if (a[i]!=b[i]) break;
        return i;
} //Comp

//    
int symsearch (char *p)
{ int i, res, n;
  unsigned c;
   if (*p==0) return 0;
retry:
   for (i=0; syms[i].code; i++)
   {    n=Comp(syms[i].str,p);
        //   ,   
        if ((n<StrLen(p))&&(n==StrLen(syms[i].str))&&(syms[i].link))
        {    res=symsearch(p+n);        //   
             if (res==syms[i].link) return syms[i].code;
             continue;
        }
        if (n<StrLen(p)) continue;
        if (n==StrLen(syms[i].str))     //  
        {    if (syms[i].link==0) return syms[i].code;
             res=symsearch(p+StrLen(syms[i].str));
             if (res==syms[i].link) return syms[i].code;
             if (res<=0) return -1;
        }
        else                            //   
        {    do c=gs(); while (c==0);
             p[strlen(p)]=c;
             goto retry;
        }
   }
   return -1;
} //symsearch

int getsym0 ()
{ char sym[MAXSYM];
  char *p;
  int i,res;
  unsigned c;
        fflush(stdout);
        if (ctrl)
        {       do res=gs();
                while (res==0);
                return res;
        }
        for (i=0; i<MAXSYM; i++) sym[i]=0;
        for (p=sym; (p-sym)<MAXSYM; p++)
        {    c=gs();
             if (c==0) return _Reframe;
             *p=c;
             res=symsearch(sym);
             if (res>0) return res;
             if (res==0) continue;
             if (StrLen(sym)==1)
             {  unsigned char c=sym[0];
                if (_rusmap==NULL) return c;
                if (c==_RusLat) { RUS=!RUS; return 0; }
                if (RUS==0) return c;
                if ((c<' ')||(c>=128)) return c;
                return (unsigned char)RusMap[c-' '+64];
             }
             else return -1;
        }
        return -1;
} // getsym0

int reading=0;
jmp_buf jump;

int macro[MAXMACRO+1];
int define, play, repeat;
int m;
int getsym()
{ int c;
        if (setjmp(jump)) return _Refresh;
        reading=1;
ree:    if (play)
        {       if ((m<MAXMACRO)&&macro[m]) return macro[m++];
                repeat--;
                m=0;
                if (repeat<=0) play=0;
                else goto ree;
        }

        c=getsym0();
        reading=0;
        switch (c)
        { case _def:
                define=!define;
                return 0;
          case _play:
                play=!play;
                m=0;
                define=0;
                repeat=1;
                goto ree;
        }
        if (define&&m<MAXMACRO)
        {       macro[m++]=c;
                macro[m]=0;
        }
        else m=0;
        return c;
} //getsym


