//
//    
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "head.h"

#define MaxFiles 16

extern void makeswap();
FILE *Swap;
char SwapName[256];

VPtr *fFirst, *fLast;   //     
char T[MAXSTR];         // 

struct { FILE *Ptr;
         int Count;
       } FileMap[MaxFiles+1];

void LineRead (FILE *f, char *S)
{ int c;
        for (int i=0; i<MAXSTR-1; i++)            //  
        {   c=fgetc(f);
            if (feof(f)||(c==012))
            {   *S=0;
                break;
            }
            if (c=='Z'-0100)
            {   *S++=c;
                *S=0;
                break;
            }
            *S++=c;
        } //for
        *S=0;
} //LineRead

//   
void BackRead (FILE *f, char *S)
{ int i,c;
  char T[MAXSTR];
        for (i=0; i<MAXSTR; i++)            //  
        {   fseek(f,-1L,SEEK_CUR);
            c=fgetc(f);
#ifdef __MSDOS__
            if (c==012) fseek(f,-1L,SEEK_CUR);
#endif
            fseek(f,-1L,SEEK_CUR);
            if ((ftell(f)==0)||(c==012))
            {   T[i]=0;
                break;
            }
            T[i]=c;
        } //for
        i--;
        for (; i>=0; i--)
           *S++=T[i];
        *S=0;
} //BackRead

long AddFile (FILE *P)
{ int i;
        for (i=1; i<=MaxFiles; i++)
            if (FileMap[i].Ptr==P) break;
        if (i>MaxFiles)
        {       for (i=1; i<=MaxFiles; i++)
                    if (FileMap[i].Count<=0) break;
                if (i>MaxFiles) return 0;
                FileMap[i].Ptr=P;
        }
        ++FileMap[i].Count;
        return i;
} //AddFile

void DoneFile (int i)
{   if ((i>0) && (i<=MaxFiles))
    {   if (FileMap[i].Ptr==NULL) return;
        --FileMap[i].Count;
        if (FileMap[i].Count<=0) FileMap[i].Ptr=NULL;
    }
} //DoneFile

FILE *FPtr (VStr *P)
{    if ((P->FNum>0) && (P->FNum<=MaxFiles))
           return FileMap[P->FNum].Ptr;
     else  return NULL;
} //FPtr

int IsEmpty (VStr *P)
{   return P->FNum==0;
} //IsEmpty

void saveVStr (VStr *P);
void loadVStr (VStr *P);

int ResCount=0;
int AllCount=0;

void Exclude (VPtr *P)
{    if (P==NULL) return;
     if (P->Prev!=NULL) P->Prev->Next=P->Next;
     if (P->Next!=NULL) P->Next->Prev=P->Prev;
     if (fFirst==P) fFirst=P->Next;
     if (fLast==P) fLast=P->Prev;
     --ResCount;
} //Exclude

void AddToEnd (VPtr *P)
{    if (fLast!=NULL) fLast->Next=P;
     P->Prev=fLast;
     P->Next=NULL;
     fLast=P;
     if (fFirst==NULL) fFirst=P;
     ++ResCount;
} //AddToEnd

//   
void MoveToEnd (VPtr *P)
{    if ((fLast==NULL)||(fFirst==NULL)||(fFirst==fLast)) return;
     if (P==fLast) return;
     Exclude(P);
     AddToEnd(P);
} //MoveToEnd

//      
void delFirst()
{ VPtr *P;
     if ((fLast==NULL)||(fFirst==NULL)||(fFirst==fLast)) return;
     P=fFirst;
     fFirst=P->Next;
     fFirst->Prev=NULL;
     if (P->Owner!=NULL)
     {  if (P->Owner->Modified)
           saveVStr(P->Owner);     //  
        P->Owner->Ptr=(VPtr *)P->Pos;
        P->Owner->Resident=0;
     }
     delete P;
     --ResCount;
} //delFirst

void FreeVMemory()
{    while ((ResCount>=MaxResCount) && (fFirst!=fLast)) delFirst();
} //FreeVMemory

int AllResident()
{       return AllCount<=ResCount;
}

void CleanVStrings()
{ VPtr *P;
     while (fFirst!=NULL)
     {     P=fFirst;
           fFirst=P->Next;
           delete P;
     }
} //CleanVStrings

// --- ---

//    
void loadVStr (VStr *P)
{ long Pos;
        if (P->Resident) return;
        FILE *F=FPtr(P);
        if (F==NULL) return;
        Pos=(long)P->Ptr;
        P->Resident=1;
        FreeVMemory();
        fseek(F,Pos,SEEK_SET);
        LineRead(F,T);
        P->Ptr=(VPtr*)malloc(sizeof(VPtr)+strlen(T));
        strcpy(P->Ptr->S,T);
        P->Ptr->Pos=Pos;
        P->Ptr->Owner=P;
        AddToEnd(P->Ptr);
} //loadVStr

//   
void saveVStr (VStr *P)
{ char *pp;
        if (!P->Resident) return;
        FILE *F=FPtr(P);
        if (FPtr(P)==NULL) return;
        fseek(F,0,SEEK_END);
        P->Ptr->Pos=ftell(F);
        if (P->Ptr->S)
        {  for (pp=P->Ptr->S; *pp; pp++)
                putc(*pp,F);
           putc('\n',F);
        }
        P->Modified=0;
} //saveVStr

// --- ---

//    
char *GetVStr (VStr *P)
{       if (P==NULL)
                return "";
        if (!P->Resident)
                loadVStr(P);             //  
        else    MoveToEnd(P->Ptr);
        if (P->FNum==0)
                return "";
        else if (P->Ptr->S==NULL)
                return "";
        else  return P->Ptr->S;
} //GetVStr

//  
VStr *SetVStr (FILE *Stream, long p, char *S)
{       if (Stream==NULL) return NULL;
        VStr *P = (VStr*)calloc(1,sizeof(VStr));
        if (S)
        {       FreeVMemory();
                P->Modified=0; P->FNum=0;
                if (*S) P->FNum=AddFile(Stream);
                P->Resident=1;
                P->Ptr=(VPtr*)malloc(sizeof(VPtr)+strlen(S));
                strcpy(P->Ptr->S,S);
                P->Ptr->Pos=p;
                P->Ptr->Owner=P;
                AddToEnd(P->Ptr);
                FreeVMemory();
        }
        else
        {       P->FNum=AddFile(Stream);
                P->Modified=0; P->Resident=0;
                P->Ptr=(VPtr *)p;
        }
        ++AllCount;
        return P;
} //SetVStr

//   
VStr *NewVStr (char *S)
{ VStr *P=(VStr*)calloc(1,sizeof(VStr));
        FreeVMemory();
        P->FNum=0; P->Modified=0;     // 
        if (*S)
        {    makeswap();
             P->FNum=AddFile(Swap);
             P->Modified=1;
        }
        P->Resident=1;

        P->Ptr=(VPtr*)malloc(sizeof(VPtr)+strlen(S));
        strcpy(P->Ptr->S,S);
        P->Ptr->Pos=-1;
        P->Ptr->Owner=P;

        AddToEnd(P->Ptr);
        FreeVMemory();
        ++AllCount;
        return P;
} //NewVStr

//      ()
VStr *ReadVStr (FILE *Stream)
{ VStr *P=(VStr*)calloc(1,sizeof(VStr));

        LineRead(Stream,T);
        FreeVMemory();
        makeswap();
        P->FNum=AddFile(Swap);
        P->Modified=1; P->Resident=1;
        P->Ptr=(VPtr*)malloc(sizeof(VPtr)+strlen(T));
        strcpy(P->Ptr->S,T);
        P->Ptr->Pos=-1;
        P->Ptr->Owner=P;
        AddToEnd(P->Ptr);
        if (P->Ptr->S==NULL)
        {       DoneFile(P->FNum);
                P->FNum=0; P->Modified=0; P->Resident=0;   // 
        }
        FreeVMemory();
        ++AllCount;
        return P;
} //ReadVStr

//   
void DisposeVStr (VStr *P)
{       if (P==NULL) return;
        if (P->Resident)
        {   P->Ptr->Owner=NULL;
            Exclude(P->Ptr);
            delete P->Ptr;
        }
        DoneFile(P->FNum);
        --AllCount;
        delete P;
} //DisposeVStr

void ClearVStr (VStr *P)
{       if (P==NULL) return;
        if (P->Resident)
        {   P->Ptr->Owner=NULL;
            Exclude(P->Ptr);
            delete P->Ptr;
        }
        DoneFile(P->FNum);
        P->FNum=0;
} //ClearVStr

GapStr::GapStr (FILE *Stream)
{       isGap=1;
        Prev=Next=NULL;
        Ptr=NULL;
        Resident=Modified=0;
        FNum=AddFile(Stream);
} //GapStr::GapStr

//   
VStr *Edit::GetNext (VStr *P)
{       if (!P->Next || !P->Next->isGap)
                return (VStr*)P->Next;
        char S[MAXSTR+1];       //  ""
        GapStr *Gap=(GapStr*)P->Next;
        FILE *f=FPtr(Gap);
        fseek(f,Gap->A,SEEK_SET);
        LineRead(f,S);
        VStr *L=::SetVStr(f,Gap->A,S);
        Gap->A=ftell(f);
        ++Lines;
        if (Gap->A<Gap->B)
        {       L->Next=P->Next;
                L->Prev=P;
                P->Next->Prev=L;
                P->Next=L;
        }
        else    //
        {       L->Next=P->Next->Next;
                L->Prev=P;
                P->Next->Next->Prev=L;
                P->Next=L;
                DisposeVStr(Gap);
                --GapCnt;
                if ((GapCnt<=0)&&(Lineno<0)) Lineno+=Lines+1;
                if (view)
                        ((EWindow*)Owner)->VFrame(0);
                else    ((EWindow*)Owner)->EFrame(0);
        }
        return L;
} //GetNext

//   
VStr *Edit::GetPrev (VStr *P)
{       if (!P->Prev || !P->Prev->isGap)
                return (VStr*)P->Prev;
        char S[MAXSTR+1];       //  ""
        GapStr *Gap=(GapStr*)P->Prev;
        FILE *f=FPtr(Gap);
        fseek(f,Gap->B,SEEK_SET);
        BackRead(f,S);
        Gap->B=ftell(f);
        VStr *L=SetVStr(f,Gap->B+LFsize,S);
        ++Lines;
        if (Gap->A<Gap->B)
        {       L->Prev=P->Prev;
                L->Next=P;
                P->Prev->Next=L;
                P->Prev=L;
        }
        else    //
        {       L->Prev=P->Prev->Prev;
                L->Next=P;
                P->Prev->Prev->Next=L;
                P->Prev=L;
                DisposeVStr(Gap);
                --GapCnt;
                if ((GapCnt<=0)&&(Lineno<0)) Lineno+=Lines+1;
                if (view)
                        ((EWindow*)Owner)->VFrame(0);
                else    ((EWindow*)Owner)->EFrame(0);
        }
        return (VStr*)P->Prev;
} //GetPrev

